<?php


namespace NOUT;


use NOUT\Soap\EnumType\ReturnType;
use NOUT\Soap\StructType\Execute;
use NOUT\Soap\StructType\XmlType;

class AffichageFiche extends NOUTClient
{
    /**
     * @param       $idAction
     * @param array $aTabParams
     *
     * @return mixed|string|null
     * @throws \Exception
     */
    protected function _execute($idAction, array $aTabParams)
    {
        $stParam = new Execute($idAction, null, $this->_TabParams2ParamXML($aTabParams));
        $resultRequest = $this->clSoapService->Execute($stParam);
        $this->_writeLog($this->clSoapService);

        $returnType = $this->clSoapService->getSoapHeaderReturnType();

        return $this->_TraiteRetour($resultRequest, $returnType);
    }


    /**
     * @param XmlType $resultRequest
     * @param string $returnType
     * @param string $sOrigine
     *
     * @return mixed|string|null
     * @throws \Exception
     */
    protected function _TraiteRetour(XmlType $resultRequest, string $returnType, string $sOrigine='')
    {
        switch ($returnType)
        {
            case ReturnType::VALUE_RECORD:
            {
                return simplexml_load_string($resultRequest->getXml());
            }
        }

        return parent::_TraiteRetour($resultRequest, $returnType, $sOrigine);
    }
}
