<?php


namespace NOUT;

use NOUT\Soap\EnumType\ReturnType;
use NOUT\Entity\ConfirmResponse;
use NOUT\Soap\StructType\ExecuteResponse;
use NOUT\Soap\StructType\XmlType;

class DeclenchementAutoClient extends NOUTClient
{
    /**
     * @param       $idAction
     * @param array $aTabParams
     *
     * @return mixed|string|null
     * @throws \Exception
     */
    protected function _execute($idAction, array $aTabParams)
    {
        return $this->_executeAction($idAction, $aTabParams, null);
    }

    /**
     * @param XmlType $resultRequest
     * @param string $returnType
     * @param string $sOrigine
     *
     * @return mixed|string|null
     * @throws \Exception
     */
    protected function _TraiteRetour(XmlType $resultRequest, string $returnType, string $sOrigine='')
    {
        switch ($returnType)
        {
            case ReturnType::VALUE_MESSAGE_BOX:
            {
                /** @var ExecuteResponse $resultRequest*/
                $xml = simplexml_load_string($resultRequest->getXml());
                $json = $this->_GetJSONFromMessageBox($xml->MessageBox);
                if ($json){
                    $this->_ConfirmMessageBox(ConfirmResponse::IDOK);
                    return $json;
                }
                break;
            }
        }

        return parent::_TraiteRetour($resultRequest, $returnType, $sOrigine);
    }
}
