<?php

declare(strict_types=1);

namespace NOUT\Soap\EnumType;

use NOUT\Soap\PackageBase\AbstractStructEnumBase;

/**
 * This class stands for ChartTypeEnum EnumType
 * @subpackage Enumerations
 */
class ChartTypeEnum extends AbstractStructEnumBase
{
    /**
     * Constant for value 'pie'
     * @return string 'pie'
     */
    const VALUE_PIE = 'pie';
    /**
     * Constant for value 'column'
     * @return string 'column'
     */
    const VALUE_COLUMN = 'column';
    /**
     * Constant for value 'stackedColumn'
     * @return string 'stackedColumn'
     */
    const VALUE_STACKED_COLUMN = 'stackedColumn';
    /**
     * Constant for value 'line'
     * @return string 'line'
     */
    const VALUE_LINE = 'line';
    /**
     * Constant for value 'bubble'
     * @return string 'bubble'
     */
    const VALUE_BUBBLE = 'bubble';
    /**
     * Return allowed values
     * @uses self::VALUE_PIE
     * @uses self::VALUE_COLUMN
     * @uses self::VALUE_STACKED_COLUMN
     * @uses self::VALUE_LINE
     * @uses self::VALUE_BUBBLE
     * @return string[]
     */
    public static function getValidValues(): array
    {
        return [
            self::VALUE_PIE,
            self::VALUE_COLUMN,
            self::VALUE_STACKED_COLUMN,
            self::VALUE_LINE,
            self::VALUE_BUBBLE,
        ];
    }
}
