<?php

declare(strict_types=1);

namespace NOUT\Soap\EnumType;

use NOUT\Soap\PackageBase\AbstractStructEnumBase;

/**
 * This class stands for WayEnum EnumType
 * @subpackage Enumerations
 */
class WayEnum extends AbstractStructEnumBase
{
    /**
     * Constant for value 'Received'
     * @return string 'Received'
     */
    const VALUE_RECEIVED = 'Received';
    /**
     * Constant for value 'Sent'
     * @return string 'Sent'
     */
    const VALUE_SENT = 'Sent';
    /**
     * Constant for value 'All'
     * @return string 'All'
     */
    const VALUE_ALL = 'All';
    /**
     * Return allowed values
     * @uses self::VALUE_RECEIVED
     * @uses self::VALUE_SENT
     * @uses self::VALUE_ALL
     * @return string[]
     */
    public static function getValidValues(): array
    {
        return [
            self::VALUE_RECEIVED,
            self::VALUE_SENT,
            self::VALUE_ALL,
        ];
    }
}
