<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for Action StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class Action extends AbstractStructBase
{
    /**
     * The _
     * @var string|null
     */
    protected ?string $_ = null;
    /**
     * The title
     * @var string|null
     */
    protected ?string $title = null;
    /**
     * The typeaction
     * @var string|null
     */
    protected ?string $typeaction = null;
    /**
     * The typereturn
     * @var string|null
     */
    protected ?string $typereturn = null;
    /**
     * The actionForm
     * @var string|null
     */
    protected ?string $actionForm = null;
    /**
     * The assistantMode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int|null
     */
    protected ?int $assistantMode = null;
    /**
     * The isConfiguration
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int|null
     */
    protected ?int $isConfiguration = null;
    /**
     * The userConfirmation
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int|null
     */
    protected ?int $userConfirmation = null;
    /**
     * Constructor method for Action
     * @uses Action::set_()
     * @uses Action::setTitle()
     * @uses Action::setTypeaction()
     * @uses Action::setTypereturn()
     * @uses Action::setActionForm()
     * @uses Action::setAssistantMode()
     * @uses Action::setIsConfiguration()
     * @uses Action::setUserConfirmation()
     * @param string $_
     * @param string $title
     * @param string $typeaction
     * @param string $typereturn
     * @param string $actionForm
     * @param int $assistantMode
     * @param int $isConfiguration
     * @param int $userConfirmation
     */
    public function __construct(?string $_ = null, ?string $title = null, ?string $typeaction = null, ?string $typereturn = null, ?string $actionForm = null, ?int $assistantMode = null, ?int $isConfiguration = null, ?int $userConfirmation = null)
    {
        $this
            ->set_($_)
            ->setTitle($title)
            ->setTypeaction($typeaction)
            ->setTypereturn($typereturn)
            ->setActionForm($actionForm)
            ->setAssistantMode($assistantMode)
            ->setIsConfiguration($isConfiguration)
            ->setUserConfirmation($userConfirmation);
    }
    /**
     * Get _ value
     * @return string|null
     */
    public function get_(): ?string
    {
        return $this->_;
    }
    /**
     * Set _ value
     * @param string $_
     * @return \NOUT\Soap\StructType\Action
     */
    public function set_(?string $_ = null): self
    {
        // validation for constraint: string
        if (!is_null($_) && !is_string($_)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($_, true), gettype($_)), __LINE__);
        }
        $this->_ = $_;
        
        return $this;
    }
    /**
     * Get title value
     * @return string|null
     */
    public function getTitle(): ?string
    {
        return $this->title;
    }
    /**
     * Set title value
     * @param string $title
     * @return \NOUT\Soap\StructType\Action
     */
    public function setTitle(?string $title = null): self
    {
        // validation for constraint: string
        if (!is_null($title) && !is_string($title)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($title, true), gettype($title)), __LINE__);
        }
        $this->title = $title;
        
        return $this;
    }
    /**
     * Get typeaction value
     * @return string|null
     */
    public function getTypeaction(): ?string
    {
        return $this->typeaction;
    }
    /**
     * Set typeaction value
     * @param string $typeaction
     * @return \NOUT\Soap\StructType\Action
     */
    public function setTypeaction(?string $typeaction = null): self
    {
        // validation for constraint: string
        if (!is_null($typeaction) && !is_string($typeaction)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($typeaction, true), gettype($typeaction)), __LINE__);
        }
        $this->typeaction = $typeaction;
        
        return $this;
    }
    /**
     * Get typereturn value
     * @return string|null
     */
    public function getTypereturn(): ?string
    {
        return $this->typereturn;
    }
    /**
     * Set typereturn value
     * @param string $typereturn
     * @return \NOUT\Soap\StructType\Action
     */
    public function setTypereturn(?string $typereturn = null): self
    {
        // validation for constraint: string
        if (!is_null($typereturn) && !is_string($typereturn)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($typereturn, true), gettype($typereturn)), __LINE__);
        }
        $this->typereturn = $typereturn;
        
        return $this;
    }
    /**
     * Get actionForm value
     * @return string|null
     */
    public function getActionForm(): ?string
    {
        return $this->actionForm;
    }
    /**
     * Set actionForm value
     * @param string $actionForm
     * @return \NOUT\Soap\StructType\Action
     */
    public function setActionForm(?string $actionForm = null): self
    {
        // validation for constraint: string
        if (!is_null($actionForm) && !is_string($actionForm)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($actionForm, true), gettype($actionForm)), __LINE__);
        }
        $this->actionForm = $actionForm;
        
        return $this;
    }
    /**
     * Get assistantMode value
     * @return int|null
     */
    public function getAssistantMode(): ?int
    {
        return $this->assistantMode;
    }
    /**
     * Set assistantMode value
     * @param int $assistantMode
     * @return \NOUT\Soap\StructType\Action
     */
    public function setAssistantMode(?int $assistantMode = null): self
    {
        // validation for constraint: int
        if (!is_null($assistantMode) && !(is_int($assistantMode) || ctype_digit($assistantMode))) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($assistantMode, true), gettype($assistantMode)), __LINE__);
        }
        $this->assistantMode = $assistantMode;
        
        return $this;
    }
    /**
     * Get isConfiguration value
     * @return int|null
     */
    public function getIsConfiguration(): ?int
    {
        return $this->isConfiguration;
    }
    /**
     * Set isConfiguration value
     * @param int $isConfiguration
     * @return \NOUT\Soap\StructType\Action
     */
    public function setIsConfiguration(?int $isConfiguration = null): self
    {
        // validation for constraint: int
        if (!is_null($isConfiguration) && !(is_int($isConfiguration) || ctype_digit($isConfiguration))) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($isConfiguration, true), gettype($isConfiguration)), __LINE__);
        }
        $this->isConfiguration = $isConfiguration;
        
        return $this;
    }
    /**
     * Get userConfirmation value
     * @return int|null
     */
    public function getUserConfirmation(): ?int
    {
        return $this->userConfirmation;
    }
    /**
     * Set userConfirmation value
     * @param int $userConfirmation
     * @return \NOUT\Soap\StructType\Action
     */
    public function setUserConfirmation(?int $userConfirmation = null): self
    {
        // validation for constraint: int
        if (!is_null($userConfirmation) && !(is_int($userConfirmation) || ctype_digit($userConfirmation))) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($userConfirmation, true), gettype($userConfirmation)), __LINE__);
        }
        $this->userConfirmation = $userConfirmation;
        
        return $this;
    }
}
