<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for ActionFromMessage StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class ActionFromMessage extends AbstractStructBase
{
    /**
     * The SpecialParamList
     * @var \NOUT\Soap\StructType\SpecialParamListType|null
     */
    protected ?\NOUT\Soap\StructType\SpecialParamListType $SpecialParamList = null;
    /**
     * The IDMessage
     * @var string|null
     */
    protected ?string $IDMessage = null;
    /**
     * The IDAutomatism
     * @var string|null
     */
    protected ?string $IDAutomatism = null;
    /**
     * Constructor method for ActionFromMessage
     * @uses ActionFromMessage::setSpecialParamList()
     * @uses ActionFromMessage::setIDMessage()
     * @uses ActionFromMessage::setIDAutomatism()
     * @param \NOUT\Soap\StructType\SpecialParamListType $specialParamList
     * @param string $iDMessage
     * @param string $iDAutomatism
     */
    public function __construct(?\NOUT\Soap\StructType\SpecialParamListType $specialParamList = null, ?string $iDMessage = null, ?string $iDAutomatism = null)
    {
        $this
            ->setSpecialParamList($specialParamList)
            ->setIDMessage($iDMessage)
            ->setIDAutomatism($iDAutomatism);
    }
    /**
     * Get SpecialParamList value
     * @return \NOUT\Soap\StructType\SpecialParamListType|null
     */
    public function getSpecialParamList(): ?\NOUT\Soap\StructType\SpecialParamListType
    {
        return $this->SpecialParamList;
    }
    /**
     * Set SpecialParamList value
     * @param \NOUT\Soap\StructType\SpecialParamListType $specialParamList
     * @return \NOUT\Soap\StructType\ActionFromMessage
     */
    public function setSpecialParamList(?\NOUT\Soap\StructType\SpecialParamListType $specialParamList = null): self
    {
        $this->SpecialParamList = $specialParamList;
        
        return $this;
    }
    /**
     * Get IDMessage value
     * @return string|null
     */
    public function getIDMessage(): ?string
    {
        return $this->IDMessage;
    }
    /**
     * Set IDMessage value
     * @param string $iDMessage
     * @return \NOUT\Soap\StructType\ActionFromMessage
     */
    public function setIDMessage(?string $iDMessage = null): self
    {
        // validation for constraint: string
        if (!is_null($iDMessage) && !is_string($iDMessage)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($iDMessage, true), gettype($iDMessage)), __LINE__);
        }
        $this->IDMessage = $iDMessage;
        
        return $this;
    }
    /**
     * Get IDAutomatism value
     * @return string|null
     */
    public function getIDAutomatism(): ?string
    {
        return $this->IDAutomatism;
    }
    /**
     * Set IDAutomatism value
     * @param string $iDAutomatism
     * @return \NOUT\Soap\StructType\ActionFromMessage
     */
    public function setIDAutomatism(?string $iDAutomatism = null): self
    {
        // validation for constraint: string
        if (!is_null($iDAutomatism) && !is_string($iDAutomatism)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($iDAutomatism, true), gettype($iDAutomatism)), __LINE__);
        }
        $this->IDAutomatism = $iDAutomatism;
        
        return $this;
    }
}
