<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for AuditAction StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class AuditAction extends AbstractStructBase
{
    /**
     * The ID
     * @var string|null
     */
    protected ?string $ID = null;
    /**
     * The ParamXML
     * @var string|null
     */
    protected ?string $ParamXML = null;
    /**
     * The VirtualParamList
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \NOUT\Soap\StructType\VirtualParamListType|null
     */
    protected ?\NOUT\Soap\StructType\VirtualParamListType $VirtualParamList = null;
    /**
     * Constructor method for AuditAction
     * @uses AuditAction::setID()
     * @uses AuditAction::setParamXML()
     * @uses AuditAction::setVirtualParamList()
     * @param string $iD
     * @param string $paramXML
     * @param \NOUT\Soap\StructType\VirtualParamListType $virtualParamList
     */
    public function __construct(?string $iD = null, ?string $paramXML = null, ?\NOUT\Soap\StructType\VirtualParamListType $virtualParamList = null)
    {
        $this
            ->setID($iD)
            ->setParamXML($paramXML)
            ->setVirtualParamList($virtualParamList);
    }
    /**
     * Get ID value
     * @return string|null
     */
    public function getID(): ?string
    {
        return $this->ID;
    }
    /**
     * Set ID value
     * @param string $iD
     * @return \NOUT\Soap\StructType\AuditAction
     */
    public function setID(?string $iD = null): self
    {
        // validation for constraint: string
        if (!is_null($iD) && !is_string($iD)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($iD, true), gettype($iD)), __LINE__);
        }
        $this->ID = $iD;
        
        return $this;
    }
    /**
     * Get ParamXML value
     * @return string|null
     */
    public function getParamXML(): ?string
    {
        return $this->ParamXML;
    }
    /**
     * Set ParamXML value
     * @param string $paramXML
     * @return \NOUT\Soap\StructType\AuditAction
     */
    public function setParamXML(?string $paramXML = null): self
    {
        // validation for constraint: string
        if (!is_null($paramXML) && !is_string($paramXML)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($paramXML, true), gettype($paramXML)), __LINE__);
        }
        $this->ParamXML = $paramXML;
        
        return $this;
    }
    /**
     * Get VirtualParamList value
     * @return \NOUT\Soap\StructType\VirtualParamListType|null
     */
    public function getVirtualParamList(): ?\NOUT\Soap\StructType\VirtualParamListType
    {
        return $this->VirtualParamList;
    }
    /**
     * Set VirtualParamList value
     * @param \NOUT\Soap\StructType\VirtualParamListType $virtualParamList
     * @return \NOUT\Soap\StructType\AuditAction
     */
    public function setVirtualParamList(?\NOUT\Soap\StructType\VirtualParamListType $virtualParamList = null): self
    {
        $this->VirtualParamList = $virtualParamList;
        
        return $this;
    }
}
