<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for Cancel StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class Cancel extends AbstractStructBase
{
    /**
     * The Context
     * @var int|null
     */
    protected ?int $Context = null;
    /**
     * The ByUser
     * @var int|null
     */
    protected ?int $ByUser = null;
    /**
     * Constructor method for Cancel
     * @uses Cancel::setContext()
     * @uses Cancel::setByUser()
     * @param int $context
     * @param int $byUser
     */
    public function __construct(?int $context = null, ?int $byUser = null)
    {
        $this
            ->setContext($context)
            ->setByUser($byUser);
    }
    /**
     * Get Context value
     * @return int|null
     */
    public function getContext(): ?int
    {
        return $this->Context;
    }
    /**
     * Set Context value
     * @param int $context
     * @return \NOUT\Soap\StructType\Cancel
     */
    public function setContext(?int $context = null): self
    {
        // validation for constraint: int
        if (!is_null($context) && !(is_int($context) || ctype_digit($context))) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($context, true), gettype($context)), __LINE__);
        }
        $this->Context = $context;
        
        return $this;
    }
    /**
     * Get ByUser value
     * @return int|null
     */
    public function getByUser(): ?int
    {
        return $this->ByUser;
    }
    /**
     * Set ByUser value
     * @param int $byUser
     * @return \NOUT\Soap\StructType\Cancel
     */
    public function setByUser(?int $byUser = null): self
    {
        // validation for constraint: int
        if (!is_null($byUser) && !(is_int($byUser) || ctype_digit($byUser))) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($byUser, true), gettype($byUser)), __LINE__);
        }
        $this->ByUser = $byUser;
        
        return $this;
    }
}
