<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for CheckCtrlResponse StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class CheckCtrlResponse extends AbstractStructBase
{
    /**
     * The Value
     * @var int|null
     */
    protected ?int $Value = null;
    /**
     * The RecordError
     * @var \NOUT\Soap\StructType\ValidateError|null
     */
    protected ?\NOUT\Soap\StructType\ValidateError $RecordError = null;
    /**
     * The CtrlError
     * @var \NOUT\Soap\StructType\ValidateError|null
     */
    protected ?\NOUT\Soap\StructType\ValidateError $CtrlError = null;
    /**
     * Constructor method for CheckCtrlResponse
     * @uses CheckCtrlResponse::setValue()
     * @uses CheckCtrlResponse::setRecordError()
     * @uses CheckCtrlResponse::setCtrlError()
     * @param int $value
     * @param \NOUT\Soap\StructType\ValidateError $recordError
     * @param \NOUT\Soap\StructType\ValidateError $ctrlError
     */
    public function __construct(?int $value = null, ?\NOUT\Soap\StructType\ValidateError $recordError = null, ?\NOUT\Soap\StructType\ValidateError $ctrlError = null)
    {
        $this
            ->setValue($value)
            ->setRecordError($recordError)
            ->setCtrlError($ctrlError);
    }
    /**
     * Get Value value
     * @return int|null
     */
    public function getValue(): ?int
    {
        return $this->Value;
    }
    /**
     * Set Value value
     * @param int $value
     * @return \NOUT\Soap\StructType\CheckCtrlResponse
     */
    public function setValue(?int $value = null): self
    {
        // validation for constraint: int
        if (!is_null($value) && !(is_int($value) || ctype_digit($value))) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($value, true), gettype($value)), __LINE__);
        }
        $this->Value = $value;
        
        return $this;
    }
    /**
     * Get RecordError value
     * @return \NOUT\Soap\StructType\ValidateError|null
     */
    public function getRecordError(): ?\NOUT\Soap\StructType\ValidateError
    {
        return $this->RecordError;
    }
    /**
     * Set RecordError value
     * @param \NOUT\Soap\StructType\ValidateError $recordError
     * @return \NOUT\Soap\StructType\CheckCtrlResponse
     */
    public function setRecordError(?\NOUT\Soap\StructType\ValidateError $recordError = null): self
    {
        $this->RecordError = $recordError;
        
        return $this;
    }
    /**
     * Get CtrlError value
     * @return \NOUT\Soap\StructType\ValidateError|null
     */
    public function getCtrlError(): ?\NOUT\Soap\StructType\ValidateError
    {
        return $this->CtrlError;
    }
    /**
     * Set CtrlError value
     * @param \NOUT\Soap\StructType\ValidateError $ctrlError
     * @return \NOUT\Soap\StructType\CheckCtrlResponse
     */
    public function setCtrlError(?\NOUT\Soap\StructType\ValidateError $ctrlError = null): self
    {
        $this->CtrlError = $ctrlError;
        
        return $this;
    }
}
