<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for ConfirmResponse StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class ConfirmResponse extends AbstractStructBase
{
    /**
     * The TypeConfirmation
     * @var int|null
     */
    protected ?int $TypeConfirmation = null;
    /**
     * Constructor method for ConfirmResponse
     * @uses ConfirmResponse::setTypeConfirmation()
     * @param int $typeConfirmation
     */
    public function __construct(?int $typeConfirmation = null)
    {
        $this
            ->setTypeConfirmation($typeConfirmation);
    }
    /**
     * Get TypeConfirmation value
     * @return int|null
     */
    public function getTypeConfirmation(): ?int
    {
        return $this->TypeConfirmation;
    }
    /**
     * Set TypeConfirmation value
     * @param int $typeConfirmation
     * @return \NOUT\Soap\StructType\ConfirmResponse
     */
    public function setTypeConfirmation(?int $typeConfirmation = null): self
    {
        // validation for constraint: int
        if (!is_null($typeConfirmation) && !(is_int($typeConfirmation) || ctype_digit($typeConfirmation))) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($typeConfirmation, true), gettype($typeConfirmation)), __LINE__);
        }
        $this->TypeConfirmation = $typeConfirmation;
        
        return $this;
    }
}
