<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for ConnectedUser StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class ConnectedUser extends AbstractStructBase
{
    /**
     * The Form
     * @var \NOUT\Soap\StructType\Form|null
     */
    protected $Form = null;
    /**
     * The Element
     * @var \NOUT\Soap\StructType\Element|null
     */
    protected $Element = null;
    /**
     * The Column
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string|null
     */
    protected ?string $Column = null;
    /**
     * The PwdInfo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \NOUT\Soap\StructType\PwdInfo|null
     */
    protected $PwdInfo = null;
    /**
     * The Employee
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \NOUT\Soap\StructType\FormElement|null
     */
    protected $Employee = null;
    /**
     * The Extranet
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \NOUT\Soap\StructType\FormElement|null
     */
    protected $Extranet = null;
    /**
     * Constructor method for ConnectedUser
     * @uses ConnectedUser::setForm()
     * @uses ConnectedUser::setElement()
     * @uses ConnectedUser::setColumn()
     * @uses ConnectedUser::setPwdInfo()
     * @uses ConnectedUser::setEmployee()
     * @uses ConnectedUser::setExtranet()
     * @param \NOUT\Soap\StructType\Form $form
     * @param \NOUT\Soap\StructType\Element $element
     * @param string $column
     * @param \NOUT\Soap\StructType\PwdInfo $pwdInfo
     * @param \NOUT\Soap\StructType\FormElement $employee
     * @param \NOUT\Soap\StructType\FormElement $extranet
     */
    public function __construct(?\NOUT\Soap\StructType\Form $form = null, ?\NOUT\Soap\StructType\Element $element = null, ?string $column = null, ?\NOUT\Soap\StructType\PwdInfo $pwdInfo = null, ?\NOUT\Soap\StructType\FormElement $employee = null, ?\NOUT\Soap\StructType\FormElement $extranet = null)
    {
        $this
            ->setForm($form)
            ->setElement($element)
            ->setColumn($column)
            ->setPwdInfo($pwdInfo)
            ->setEmployee($employee)
            ->setExtranet($extranet);
    }

    /**
     * Get Form value
     * @return \NOUT\Soap\StructType\Form|null
     */
    public function getForm(): ?\NOUT\Soap\StructType\Form
    {
        return $this->Form;
    }
    /**
     * Set Form value
     * @param \NOUT\Soap\StructType\Form $form
     * @return \NOUT\Soap\StructType\ConnectedUser
     */
    public function setForm($form = null): self
    {
        $this->Form = $form;
        
        return $this;
    }
    /**
     * Get Element value
     * @return \NOUT\Soap\StructType\Element|null
     */
    public function getElement(): ?\NOUT\Soap\StructType\Element
    {
        return $this->Element;
    }
    /**
     * Set Element value
     * @param \NOUT\Soap\StructType\Element $element
     * @return \NOUT\Soap\StructType\ConnectedUser
     */
    public function setElement(?\NOUT\Soap\StructType\Element $element = null): self
    {
        $this->Element = $element;
        
        return $this;
    }
    /**
     * Get Column value
     * @return string|null
     */
    public function getColumn(): ?string
    {
        return $this->Column;
    }
    /**
     * Set Column value
     * @param string $column
     * @return \NOUT\Soap\StructType\ConnectedUser
     */
    public function setColumn(?string $column = null): self
    {
        // validation for constraint: string
        if (!is_null($column) && !is_string($column)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($column, true), gettype($column)), __LINE__);
        }
        $this->Column = $column;
        
        return $this;
    }
    /**
     * Get PwdInfo value
     * @return \NOUT\Soap\StructType\PwdInfo|null
     */
    public function getPwdInfo(): ?\NOUT\Soap\StructType\PwdInfo
    {
        return $this->PwdInfo;
    }
    /**
     * Set PwdInfo value
     * @param \NOUT\Soap\StructType\PwdInfo $pwdInfo
     * @return \NOUT\Soap\StructType\ConnectedUser
     */
    public function setPwdInfo(?\NOUT\Soap\StructType\PwdInfo $pwdInfo = null): self
    {
        $this->PwdInfo = $pwdInfo;
        
        return $this;
    }
    /**
     * Get Employee value
     * @return \NOUT\Soap\StructType\FormElement|null
     */
    public function getEmployee(): ?\NOUT\Soap\StructType\FormElement
    {
        return $this->Employee;
    }
    /**
     * Set Employee value
     * @param \NOUT\Soap\StructType\FormElement $employee
     * @return \NOUT\Soap\StructType\ConnectedUser
     */
    public function setEmployee(?\NOUT\Soap\StructType\FormElement $employee = null): self
    {
        $this->Employee = $employee;
        
        return $this;
    }
    /**
     * Get Extranet value
     * @return \NOUT\Soap\StructType\FormElement|null
     */
    public function getExtranet(): ?\NOUT\Soap\StructType\FormElement
    {
        return $this->Extranet;
    }
    /**
     * Set Extranet value
     * @param \NOUT\Soap\StructType\FormElement $extranet
     * @return \NOUT\Soap\StructType\ConnectedUser
     */
    public function setExtranet(?\NOUT\Soap\StructType\FormElement $extranet = null): self
    {
        $this->Extranet = $extranet;
        
        return $this;
    }
}
