<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for DeletePJ StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class DeletePJ extends AbstractStructBase
{
    /**
     * The IDMessage
     * @var string|null
     */
    protected ?string $IDMessage = null;
    /**
     * The IDPJ
     * @var string|null
     */
    protected ?string $IDPJ = null;
    /**
     * Constructor method for DeletePJ
     * @uses DeletePJ::setIDMessage()
     * @uses DeletePJ::setIDPJ()
     * @param string $iDMessage
     * @param string $iDPJ
     */
    public function __construct(?string $iDMessage = null, ?string $iDPJ = null)
    {
        $this
            ->setIDMessage($iDMessage)
            ->setIDPJ($iDPJ);
    }
    /**
     * Get IDMessage value
     * @return string|null
     */
    public function getIDMessage(): ?string
    {
        return $this->IDMessage;
    }
    /**
     * Set IDMessage value
     * @param string $iDMessage
     * @return \NOUT\Soap\StructType\DeletePJ
     */
    public function setIDMessage(?string $iDMessage = null): self
    {
        // validation for constraint: string
        if (!is_null($iDMessage) && !is_string($iDMessage)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($iDMessage, true), gettype($iDMessage)), __LINE__);
        }
        $this->IDMessage = $iDMessage;
        
        return $this;
    }
    /**
     * Get IDPJ value
     * @return string|null
     */
    public function getIDPJ(): ?string
    {
        return $this->IDPJ;
    }
    /**
     * Set IDPJ value
     * @param string $iDPJ
     * @return \NOUT\Soap\StructType\DeletePJ
     */
    public function setIDPJ(?string $iDPJ = null): self
    {
        // validation for constraint: string
        if (!is_null($iDPJ) && !is_string($iDPJ)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($iDPJ, true), gettype($iDPJ)), __LINE__);
        }
        $this->IDPJ = $iDPJ;
        
        return $this;
    }
}
