<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for Display StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class Display extends AbstractStructBase
{
    /**
     * The Table
     * @var string|null
     */
    protected ?string $Table = null;
    /**
     * The ParamXML
     * @var string|null
     */
    protected ?string $ParamXML = null;
    /**
     * The CallingColumn
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string|null
     */
    protected ?string $CallingColumn = null;
    /**
     * The CallingInfo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \NOUT\Soap\StructType\CallingInfoType|null
     */
    protected ?\NOUT\Soap\StructType\CallingInfoType $CallingInfo = null;
    /**
     * The VirtualParamList
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \NOUT\Soap\StructType\VirtualParamListType|null
     */
    protected ?\NOUT\Soap\StructType\VirtualParamListType $VirtualParamList = null;
    /**
     * Constructor method for Display
     * @uses Display::setTable()
     * @uses Display::setParamXML()
     * @uses Display::setCallingColumn()
     * @uses Display::setCallingInfo()
     * @uses Display::setVirtualParamList()
     * @param string $table
     * @param string $paramXML
     * @param string $callingColumn
     * @param \NOUT\Soap\StructType\CallingInfoType $callingInfo
     * @param \NOUT\Soap\StructType\VirtualParamListType $virtualParamList
     */
    public function __construct(?string $table = null, ?string $paramXML = null, ?string $callingColumn = null, ?\NOUT\Soap\StructType\CallingInfoType $callingInfo = null, ?\NOUT\Soap\StructType\VirtualParamListType $virtualParamList = null)
    {
        $this
            ->setTable($table)
            ->setParamXML($paramXML)
            ->setCallingColumn($callingColumn)
            ->setCallingInfo($callingInfo)
            ->setVirtualParamList($virtualParamList);
    }
    /**
     * Get Table value
     * @return string|null
     */
    public function getTable(): ?string
    {
        return $this->Table;
    }
    /**
     * Set Table value
     * @param string $table
     * @return \NOUT\Soap\StructType\Display
     */
    public function setTable(?string $table = null): self
    {
        // validation for constraint: string
        if (!is_null($table) && !is_string($table)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($table, true), gettype($table)), __LINE__);
        }
        $this->Table = $table;
        
        return $this;
    }
    /**
     * Get ParamXML value
     * @return string|null
     */
    public function getParamXML(): ?string
    {
        return $this->ParamXML;
    }
    /**
     * Set ParamXML value
     * @param string $paramXML
     * @return \NOUT\Soap\StructType\Display
     */
    public function setParamXML(?string $paramXML = null): self
    {
        // validation for constraint: string
        if (!is_null($paramXML) && !is_string($paramXML)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($paramXML, true), gettype($paramXML)), __LINE__);
        }
        $this->ParamXML = $paramXML;
        
        return $this;
    }
    /**
     * Get CallingColumn value
     * @return string|null
     */
    public function getCallingColumn(): ?string
    {
        return $this->CallingColumn;
    }
    /**
     * Set CallingColumn value
     * @param string $callingColumn
     * @return \NOUT\Soap\StructType\Display
     */
    public function setCallingColumn(?string $callingColumn = null): self
    {
        // validation for constraint: string
        if (!is_null($callingColumn) && !is_string($callingColumn)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($callingColumn, true), gettype($callingColumn)), __LINE__);
        }
        $this->CallingColumn = $callingColumn;
        
        return $this;
    }
    /**
     * Get CallingInfo value
     * @return \NOUT\Soap\StructType\CallingInfoType|null
     */
    public function getCallingInfo(): ?\NOUT\Soap\StructType\CallingInfoType
    {
        return $this->CallingInfo;
    }
    /**
     * Set CallingInfo value
     * @param \NOUT\Soap\StructType\CallingInfoType $callingInfo
     * @return \NOUT\Soap\StructType\Display
     */
    public function setCallingInfo(?\NOUT\Soap\StructType\CallingInfoType $callingInfo = null): self
    {
        $this->CallingInfo = $callingInfo;
        
        return $this;
    }
    /**
     * Get VirtualParamList value
     * @return \NOUT\Soap\StructType\VirtualParamListType|null
     */
    public function getVirtualParamList(): ?\NOUT\Soap\StructType\VirtualParamListType
    {
        return $this->VirtualParamList;
    }
    /**
     * Set VirtualParamList value
     * @param \NOUT\Soap\StructType\VirtualParamListType $virtualParamList
     * @return \NOUT\Soap\StructType\Display
     */
    public function setVirtualParamList(?\NOUT\Soap\StructType\VirtualParamListType $virtualParamList = null): self
    {
        $this->VirtualParamList = $virtualParamList;
        
        return $this;
    }
}
