<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for DrillThrough StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class DrillThrough extends AbstractStructBase
{
    /**
     * The Record
     * @var string|null
     */
    protected ?string $Record = null;
    /**
     * The Column
     * @var string|null
     */
    protected ?string $Column = null;
    /**
     * The SpecialParamList
     * @var \NOUT\Soap\StructType\SpecialParamListType|null
     */
    protected ?\NOUT\Soap\StructType\SpecialParamListType $SpecialParamList = null;
    /**
     * Constructor method for DrillThrough
     * @uses DrillThrough::setRecord()
     * @uses DrillThrough::setColumn()
     * @uses DrillThrough::setSpecialParamList()
     * @param string $record
     * @param string $column
     * @param \NOUT\Soap\StructType\SpecialParamListType $specialParamList
     */
    public function __construct(?string $record = null, ?string $column = null, ?\NOUT\Soap\StructType\SpecialParamListType $specialParamList = null)
    {
        $this
            ->setRecord($record)
            ->setColumn($column)
            ->setSpecialParamList($specialParamList);
    }
    /**
     * Get Record value
     * @return string|null
     */
    public function getRecord(): ?string
    {
        return $this->Record;
    }
    /**
     * Set Record value
     * @param string $record
     * @return \NOUT\Soap\StructType\DrillThrough
     */
    public function setRecord(?string $record = null): self
    {
        // validation for constraint: string
        if (!is_null($record) && !is_string($record)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($record, true), gettype($record)), __LINE__);
        }
        $this->Record = $record;
        
        return $this;
    }
    /**
     * Get Column value
     * @return string|null
     */
    public function getColumn(): ?string
    {
        return $this->Column;
    }
    /**
     * Set Column value
     * @param string $column
     * @return \NOUT\Soap\StructType\DrillThrough
     */
    public function setColumn(?string $column = null): self
    {
        // validation for constraint: string
        if (!is_null($column) && !is_string($column)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($column, true), gettype($column)), __LINE__);
        }
        $this->Column = $column;
        
        return $this;
    }
    /**
     * Get SpecialParamList value
     * @return \NOUT\Soap\StructType\SpecialParamListType|null
     */
    public function getSpecialParamList(): ?\NOUT\Soap\StructType\SpecialParamListType
    {
        return $this->SpecialParamList;
    }
    /**
     * Set SpecialParamList value
     * @param \NOUT\Soap\StructType\SpecialParamListType $specialParamList
     * @return \NOUT\Soap\StructType\DrillThrough
     */
    public function setSpecialParamList(?\NOUT\Soap\StructType\SpecialParamListType $specialParamList = null): self
    {
        $this->SpecialParamList = $specialParamList;
        
        return $this;
    }
}
