<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for Execute StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class Execute extends AbstractStructBase
{
    /**
     * The ID
     * @var string|null
     */
    protected ?string $ID = null;
    /**
     * The Sentence
     * @var string|null
     */
    protected ?string $Sentence = null;
    /**
     * The ParamXML
     * @var string|null
     */
    protected ?string $ParamXML = null;
    /**
     * The SpecialParamList
     * @var \NOUT\Soap\StructType\SpecialParamListType|null
     */
    protected ?\NOUT\Soap\StructType\SpecialParamListType $SpecialParamList = null;
    /**
     * The Checksum
     * @var int|null
     */
    protected ?int $Checksum = null;
    /**
     * The DisplayMode
     * @var string|null
     */
    protected ?string $DisplayMode = null;
    /**
     * The CallingColumn
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string|null
     */
    protected ?string $CallingColumn = null;
    /**
     * The CallingInfo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \NOUT\Soap\StructType\CallingInfoType|null
     */
    protected ?\NOUT\Soap\StructType\CallingInfoType $CallingInfo = null;
    /**
     * The BtnListMode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int|null
     */
    protected ?int $BtnListMode = null;
    /**
     * The Final
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int|null
     */
    protected ?int $Final = null;
    /**
     * The UpdateData
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string|null
     */
    protected ?string $UpdateData = null;
    /**
     * The VirtualParamList
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \NOUT\Soap\StructType\VirtualParamListType|null
     */
    protected ?\NOUT\Soap\StructType\VirtualParamListType $VirtualParamList = null;
    /**
     * Constructor method for Execute
     * @uses Execute::setID()
     * @uses Execute::setSentence()
     * @uses Execute::setParamXML()
     * @uses Execute::setSpecialParamList()
     * @uses Execute::setChecksum()
     * @uses Execute::setDisplayMode()
     * @uses Execute::setCallingColumn()
     * @uses Execute::setCallingInfo()
     * @uses Execute::setBtnListMode()
     * @uses Execute::setFinal()
     * @uses Execute::setUpdateData()
     * @uses Execute::setVirtualParamList()
     * @param string $iD
     * @param string $sentence
     * @param string $paramXML
     * @param \NOUT\Soap\StructType\SpecialParamListType $specialParamList
     * @param int $checksum
     * @param string $displayMode
     * @param string $callingColumn
     * @param \NOUT\Soap\StructType\CallingInfoType $callingInfo
     * @param int $btnListMode
     * @param int $final
     * @param string $updateData
     * @param \NOUT\Soap\StructType\VirtualParamListType $virtualParamList
     */
    public function __construct(?string $iD = null, ?string $sentence = null, ?string $paramXML = null, ?\NOUT\Soap\StructType\SpecialParamListType $specialParamList = null, ?int $checksum = null, ?string $displayMode = null, ?string $callingColumn = null, ?\NOUT\Soap\StructType\CallingInfoType $callingInfo = null, ?int $btnListMode = null, ?int $final = null, ?string $updateData = null, ?\NOUT\Soap\StructType\VirtualParamListType $virtualParamList = null)
    {
        $this
            ->setID($iD)
            ->setSentence($sentence)
            ->setParamXML($paramXML)
            ->setSpecialParamList($specialParamList)
            ->setChecksum($checksum)
            ->setDisplayMode($displayMode)
            ->setCallingColumn($callingColumn)
            ->setCallingInfo($callingInfo)
            ->setBtnListMode($btnListMode)
            ->setFinal($final)
            ->setUpdateData($updateData)
            ->setVirtualParamList($virtualParamList);
    }
    /**
     * Get ID value
     * @return string|null
     */
    public function getID(): ?string
    {
        return $this->ID;
    }
    /**
     * Set ID value
     * @param string $iD
     * @return \NOUT\Soap\StructType\Execute
     */
    public function setID(?string $iD = null): self
    {
        // validation for constraint: string
        if (!is_null($iD) && !is_string($iD)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($iD, true), gettype($iD)), __LINE__);
        }
        $this->ID = $iD;
        
        return $this;
    }
    /**
     * Get Sentence value
     * @return string|null
     */
    public function getSentence(): ?string
    {
        return $this->Sentence;
    }
    /**
     * Set Sentence value
     * @param string $sentence
     * @return \NOUT\Soap\StructType\Execute
     */
    public function setSentence(?string $sentence = null): self
    {
        // validation for constraint: string
        if (!is_null($sentence) && !is_string($sentence)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sentence, true), gettype($sentence)), __LINE__);
        }
        $this->Sentence = $sentence;
        
        return $this;
    }
    /**
     * Get ParamXML value
     * @return string|null
     */
    public function getParamXML(): ?string
    {
        return $this->ParamXML;
    }
    /**
     * Set ParamXML value
     * @param string $paramXML
     * @return \NOUT\Soap\StructType\Execute
     */
    public function setParamXML(?string $paramXML = null): self
    {
        // validation for constraint: string
        if (!is_null($paramXML) && !is_string($paramXML)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($paramXML, true), gettype($paramXML)), __LINE__);
        }
        $this->ParamXML = $paramXML;
        
        return $this;
    }
    /**
     * Get SpecialParamList value
     * @return \NOUT\Soap\StructType\SpecialParamListType|null
     */
    public function getSpecialParamList(): ?\NOUT\Soap\StructType\SpecialParamListType
    {
        return $this->SpecialParamList;
    }
    /**
     * Set SpecialParamList value
     * @param \NOUT\Soap\StructType\SpecialParamListType $specialParamList
     * @return \NOUT\Soap\StructType\Execute
     */
    public function setSpecialParamList(?\NOUT\Soap\StructType\SpecialParamListType $specialParamList = null): self
    {
        $this->SpecialParamList = $specialParamList;
        
        return $this;
    }
    /**
     * Get Checksum value
     * @return int|null
     */
    public function getChecksum(): ?int
    {
        return $this->Checksum;
    }
    /**
     * Set Checksum value
     * @param int $checksum
     * @return \NOUT\Soap\StructType\Execute
     */
    public function setChecksum(?int $checksum = null): self
    {
        // validation for constraint: int
        if (!is_null($checksum) && !(is_int($checksum) || ctype_digit($checksum))) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($checksum, true), gettype($checksum)), __LINE__);
        }
        $this->Checksum = $checksum;
        
        return $this;
    }
    /**
     * Get DisplayMode value
     * @return string|null
     */
    public function getDisplayMode(): ?string
    {
        return $this->DisplayMode;
    }
    /**
     * Set DisplayMode value
     * @uses \NOUT\Soap\EnumType\DisplayModeEnum::valueIsValid()
     * @uses \NOUT\Soap\EnumType\DisplayModeEnum::getValidValues()
     * @throws InvalidArgumentException
     * @param string $displayMode
     * @return \NOUT\Soap\StructType\Execute
     */
    public function setDisplayMode(?string $displayMode = null): self
    {
        // validation for constraint: enumeration
        if (!\NOUT\Soap\EnumType\DisplayModeEnum::valueIsValid($displayMode)) {
            throw new InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \NOUT\Soap\EnumType\DisplayModeEnum', is_array($displayMode) ? implode(', ', $displayMode) : var_export($displayMode, true), implode(', ', \NOUT\Soap\EnumType\DisplayModeEnum::getValidValues())), __LINE__);
        }
        $this->DisplayMode = $displayMode;
        
        return $this;
    }
    /**
     * Get CallingColumn value
     * @return string|null
     */
    public function getCallingColumn(): ?string
    {
        return $this->CallingColumn;
    }
    /**
     * Set CallingColumn value
     * @param string $callingColumn
     * @return \NOUT\Soap\StructType\Execute
     */
    public function setCallingColumn(?string $callingColumn = null): self
    {
        // validation for constraint: string
        if (!is_null($callingColumn) && !is_string($callingColumn)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($callingColumn, true), gettype($callingColumn)), __LINE__);
        }
        $this->CallingColumn = $callingColumn;
        
        return $this;
    }
    /**
     * Get CallingInfo value
     * @return \NOUT\Soap\StructType\CallingInfoType|null
     */
    public function getCallingInfo(): ?\NOUT\Soap\StructType\CallingInfoType
    {
        return $this->CallingInfo;
    }
    /**
     * Set CallingInfo value
     * @param \NOUT\Soap\StructType\CallingInfoType $callingInfo
     * @return \NOUT\Soap\StructType\Execute
     */
    public function setCallingInfo(?\NOUT\Soap\StructType\CallingInfoType $callingInfo = null): self
    {
        $this->CallingInfo = $callingInfo;
        
        return $this;
    }
    /**
     * Get BtnListMode value
     * @return int|null
     */
    public function getBtnListMode(): ?int
    {
        return $this->BtnListMode;
    }
    /**
     * Set BtnListMode value
     * @param int $btnListMode
     * @return \NOUT\Soap\StructType\Execute
     */
    public function setBtnListMode(?int $btnListMode = null): self
    {
        // validation for constraint: int
        if (!is_null($btnListMode) && !(is_int($btnListMode) || ctype_digit($btnListMode))) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($btnListMode, true), gettype($btnListMode)), __LINE__);
        }
        $this->BtnListMode = $btnListMode;
        
        return $this;
    }
    /**
     * Get Final value
     * @return int|null
     */
    public function getFinal(): ?int
    {
        return $this->Final;
    }
    /**
     * Set Final value
     * @param int $final
     * @return \NOUT\Soap\StructType\Execute
     */
    public function setFinal(?int $final = null): self
    {
        // validation for constraint: int
        if (!is_null($final) && !(is_int($final) || ctype_digit($final))) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($final, true), gettype($final)), __LINE__);
        }
        $this->Final = $final;
        
        return $this;
    }
    /**
     * Get UpdateData value
     * @return string|null
     */
    public function getUpdateData(): ?string
    {
        return $this->UpdateData;
    }
    /**
     * Set UpdateData value
     * @param string $updateData
     * @return \NOUT\Soap\StructType\Execute
     */
    public function setUpdateData(?string $updateData = null): self
    {
        // validation for constraint: string
        if (!is_null($updateData) && !is_string($updateData)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($updateData, true), gettype($updateData)), __LINE__);
        }
        $this->UpdateData = $updateData;
        
        return $this;
    }
    /**
     * Get VirtualParamList value
     * @return \NOUT\Soap\StructType\VirtualParamListType|null
     */
    public function getVirtualParamList(): ?\NOUT\Soap\StructType\VirtualParamListType
    {
        return $this->VirtualParamList;
    }
    /**
     * Set VirtualParamList value
     * @param \NOUT\Soap\StructType\VirtualParamListType $virtualParamList
     * @return \NOUT\Soap\StructType\Execute
     */
    public function setVirtualParamList(?\NOUT\Soap\StructType\VirtualParamListType $virtualParamList = null): self
    {
        $this->VirtualParamList = $virtualParamList;
        
        return $this;
    }
}
