<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for GetColInRecord StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class GetColInRecord extends AbstractStructBase
{
    /**
     * The Column
     * @var string|null
     */
    protected ?string $Column = null;
    /**
     * The Record
     * @var string|null
     */
    protected ?string $Record = null;
    /**
     * The Encoding
     * @var string|null
     */
    protected ?string $Encoding = null;
    /**
     * The MimeType
     * @var string|null
     */
    protected ?string $MimeType = null;
    /**
     * The TransColor
     * @var string|null
     */
    protected ?string $TransColor = null;
    /**
     * The WantContent
     * @var string|null
     */
    protected ?string $WantContent = null;
    /**
     * The ColorFrom
     * @var string|null
     */
    protected ?string $ColorFrom = null;
    /**
     * The ColorTo
     * @var string|null
     */
    protected ?string $ColorTo = null;
    /**
     * The Width
     * @var string|null
     */
    protected ?string $Width = null;
    /**
     * The Height
     * @var string|null
     */
    protected ?string $Height = null;
    /**
     * Constructor method for GetColInRecord
     * @uses GetColInRecord::setColumn()
     * @uses GetColInRecord::setRecord()
     * @uses GetColInRecord::setEncoding()
     * @uses GetColInRecord::setMimeType()
     * @uses GetColInRecord::setTransColor()
     * @uses GetColInRecord::setWantContent()
     * @uses GetColInRecord::setColorFrom()
     * @uses GetColInRecord::setColorTo()
     * @uses GetColInRecord::setWidth()
     * @uses GetColInRecord::setHeight()
     * @param string $column
     * @param string $record
     * @param string $encoding
     * @param string $mimeType
     * @param string $transColor
     * @param string $wantContent
     * @param string $colorFrom
     * @param string $colorTo
     * @param string $width
     * @param string $height
     */
    public function __construct(?string $column = null, ?string $record = null, ?string $encoding = null, ?string $mimeType = null, ?string $transColor = null, ?string $wantContent = null, ?string $colorFrom = null, ?string $colorTo = null, ?string $width = null, ?string $height = null)
    {
        $this
            ->setColumn($column)
            ->setRecord($record)
            ->setEncoding($encoding)
            ->setMimeType($mimeType)
            ->setTransColor($transColor)
            ->setWantContent($wantContent)
            ->setColorFrom($colorFrom)
            ->setColorTo($colorTo)
            ->setWidth($width)
            ->setHeight($height);
    }
    /**
     * Get Column value
     * @return string|null
     */
    public function getColumn(): ?string
    {
        return $this->Column;
    }
    /**
     * Set Column value
     * @param string $column
     * @return \NOUT\Soap\StructType\GetColInRecord
     */
    public function setColumn(?string $column = null): self
    {
        // validation for constraint: string
        if (!is_null($column) && !is_string($column)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($column, true), gettype($column)), __LINE__);
        }
        $this->Column = $column;
        
        return $this;
    }
    /**
     * Get Record value
     * @return string|null
     */
    public function getRecord(): ?string
    {
        return $this->Record;
    }
    /**
     * Set Record value
     * @param string $record
     * @return \NOUT\Soap\StructType\GetColInRecord
     */
    public function setRecord(?string $record = null): self
    {
        // validation for constraint: string
        if (!is_null($record) && !is_string($record)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($record, true), gettype($record)), __LINE__);
        }
        $this->Record = $record;
        
        return $this;
    }
    /**
     * Get Encoding value
     * @return string|null
     */
    public function getEncoding(): ?string
    {
        return $this->Encoding;
    }
    /**
     * Set Encoding value
     * @param string $encoding
     * @return \NOUT\Soap\StructType\GetColInRecord
     */
    public function setEncoding(?string $encoding = null): self
    {
        // validation for constraint: string
        if (!is_null($encoding) && !is_string($encoding)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($encoding, true), gettype($encoding)), __LINE__);
        }
        $this->Encoding = $encoding;
        
        return $this;
    }
    /**
     * Get MimeType value
     * @return string|null
     */
    public function getMimeType(): ?string
    {
        return $this->MimeType;
    }
    /**
     * Set MimeType value
     * @param string $mimeType
     * @return \NOUT\Soap\StructType\GetColInRecord
     */
    public function setMimeType(?string $mimeType = null): self
    {
        // validation for constraint: string
        if (!is_null($mimeType) && !is_string($mimeType)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($mimeType, true), gettype($mimeType)), __LINE__);
        }
        $this->MimeType = $mimeType;
        
        return $this;
    }
    /**
     * Get TransColor value
     * @return string|null
     */
    public function getTransColor(): ?string
    {
        return $this->TransColor;
    }
    /**
     * Set TransColor value
     * @param string $transColor
     * @return \NOUT\Soap\StructType\GetColInRecord
     */
    public function setTransColor(?string $transColor = null): self
    {
        // validation for constraint: string
        if (!is_null($transColor) && !is_string($transColor)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transColor, true), gettype($transColor)), __LINE__);
        }
        $this->TransColor = $transColor;
        
        return $this;
    }
    /**
     * Get WantContent value
     * @return string|null
     */
    public function getWantContent(): ?string
    {
        return $this->WantContent;
    }
    /**
     * Set WantContent value
     * @param string $wantContent
     * @return \NOUT\Soap\StructType\GetColInRecord
     */
    public function setWantContent(?string $wantContent = null): self
    {
        // validation for constraint: string
        if (!is_null($wantContent) && !is_string($wantContent)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($wantContent, true), gettype($wantContent)), __LINE__);
        }
        $this->WantContent = $wantContent;
        
        return $this;
    }
    /**
     * Get ColorFrom value
     * @return string|null
     */
    public function getColorFrom(): ?string
    {
        return $this->ColorFrom;
    }
    /**
     * Set ColorFrom value
     * @param string $colorFrom
     * @return \NOUT\Soap\StructType\GetColInRecord
     */
    public function setColorFrom(?string $colorFrom = null): self
    {
        // validation for constraint: string
        if (!is_null($colorFrom) && !is_string($colorFrom)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($colorFrom, true), gettype($colorFrom)), __LINE__);
        }
        $this->ColorFrom = $colorFrom;
        
        return $this;
    }
    /**
     * Get ColorTo value
     * @return string|null
     */
    public function getColorTo(): ?string
    {
        return $this->ColorTo;
    }
    /**
     * Set ColorTo value
     * @param string $colorTo
     * @return \NOUT\Soap\StructType\GetColInRecord
     */
    public function setColorTo(?string $colorTo = null): self
    {
        // validation for constraint: string
        if (!is_null($colorTo) && !is_string($colorTo)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($colorTo, true), gettype($colorTo)), __LINE__);
        }
        $this->ColorTo = $colorTo;
        
        return $this;
    }
    /**
     * Get Width value
     * @return string|null
     */
    public function getWidth(): ?string
    {
        return $this->Width;
    }
    /**
     * Set Width value
     * @param string $width
     * @return \NOUT\Soap\StructType\GetColInRecord
     */
    public function setWidth(?string $width = null): self
    {
        // validation for constraint: string
        if (!is_null($width) && !is_string($width)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($width, true), gettype($width)), __LINE__);
        }
        $this->Width = $width;
        
        return $this;
    }
    /**
     * Get Height value
     * @return string|null
     */
    public function getHeight(): ?string
    {
        return $this->Height;
    }
    /**
     * Set Height value
     * @param string $height
     * @return \NOUT\Soap\StructType\GetColInRecord
     */
    public function setHeight(?string $height = null): self
    {
        // validation for constraint: string
        if (!is_null($height) && !is_string($height)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($height, true), gettype($height)), __LINE__);
        }
        $this->Height = $height;
        
        return $this;
    }
}
