<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for GetContentFolder StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class GetContentFolder extends AbstractStructBase
{
    /**
     * The IDFolder
     * @var string|null
     */
    protected ?string $IDFolder = null;
    /**
     * The SpecialParamList
     * @var \NOUT\Soap\StructType\SpecialParamListType|null
     */
    protected ?\NOUT\Soap\StructType\SpecialParamListType $SpecialParamList = null;
    /**
     * Constructor method for GetContentFolder
     * @uses GetContentFolder::setIDFolder()
     * @uses GetContentFolder::setSpecialParamList()
     * @param string $iDFolder
     * @param \NOUT\Soap\StructType\SpecialParamListType $specialParamList
     */
    public function __construct(?string $iDFolder = null, ?\NOUT\Soap\StructType\SpecialParamListType $specialParamList = null)
    {
        $this
            ->setIDFolder($iDFolder)
            ->setSpecialParamList($specialParamList);
    }
    /**
     * Get IDFolder value
     * @return string|null
     */
    public function getIDFolder(): ?string
    {
        return $this->IDFolder;
    }
    /**
     * Set IDFolder value
     * @param string $iDFolder
     * @return \NOUT\Soap\StructType\GetContentFolder
     */
    public function setIDFolder(?string $iDFolder = null): self
    {
        // validation for constraint: string
        if (!is_null($iDFolder) && !is_string($iDFolder)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($iDFolder, true), gettype($iDFolder)), __LINE__);
        }
        $this->IDFolder = $iDFolder;
        
        return $this;
    }
    /**
     * Get SpecialParamList value
     * @return \NOUT\Soap\StructType\SpecialParamListType|null
     */
    public function getSpecialParamList(): ?\NOUT\Soap\StructType\SpecialParamListType
    {
        return $this->SpecialParamList;
    }
    /**
     * Set SpecialParamList value
     * @param \NOUT\Soap\StructType\SpecialParamListType $specialParamList
     * @return \NOUT\Soap\StructType\GetContentFolder
     */
    public function setSpecialParamList(?\NOUT\Soap\StructType\SpecialParamListType $specialParamList = null): self
    {
        $this->SpecialParamList = $specialParamList;
        
        return $this;
    }
}
