<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for GetListIDMessFromFolder StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class GetListIDMessFromFolder extends AbstractStructBase
{
    /**
     * The IDFolder
     * @var string|null
     */
    protected ?string $IDFolder = null;
    /**
     * The Sort1
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \NOUT\Soap\StructType\SortType|null
     */
    protected ?\NOUT\Soap\StructType\SortType $Sort1 = null;
    /**
     * The Sort2
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \NOUT\Soap\StructType\SortType|null
     */
    protected ?\NOUT\Soap\StructType\SortType $Sort2 = null;
    /**
     * The Sort3
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \NOUT\Soap\StructType\SortType|null
     */
    protected ?\NOUT\Soap\StructType\SortType $Sort3 = null;
    /**
     * Constructor method for GetListIDMessFromFolder
     * @uses GetListIDMessFromFolder::setIDFolder()
     * @uses GetListIDMessFromFolder::setSort1()
     * @uses GetListIDMessFromFolder::setSort2()
     * @uses GetListIDMessFromFolder::setSort3()
     * @param string $iDFolder
     * @param \NOUT\Soap\StructType\SortType $sort1
     * @param \NOUT\Soap\StructType\SortType $sort2
     * @param \NOUT\Soap\StructType\SortType $sort3
     */
    public function __construct(?string $iDFolder = null, ?\NOUT\Soap\StructType\SortType $sort1 = null, ?\NOUT\Soap\StructType\SortType $sort2 = null, ?\NOUT\Soap\StructType\SortType $sort3 = null)
    {
        $this
            ->setIDFolder($iDFolder)
            ->setSort1($sort1)
            ->setSort2($sort2)
            ->setSort3($sort3);
    }
    /**
     * Get IDFolder value
     * @return string|null
     */
    public function getIDFolder(): ?string
    {
        return $this->IDFolder;
    }
    /**
     * Set IDFolder value
     * @param string $iDFolder
     * @return \NOUT\Soap\StructType\GetListIDMessFromFolder
     */
    public function setIDFolder(?string $iDFolder = null): self
    {
        // validation for constraint: string
        if (!is_null($iDFolder) && !is_string($iDFolder)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($iDFolder, true), gettype($iDFolder)), __LINE__);
        }
        $this->IDFolder = $iDFolder;
        
        return $this;
    }
    /**
     * Get Sort1 value
     * @return \NOUT\Soap\StructType\SortType|null
     */
    public function getSort1(): ?\NOUT\Soap\StructType\SortType
    {
        return $this->Sort1;
    }
    /**
     * Set Sort1 value
     * @param \NOUT\Soap\StructType\SortType $sort1
     * @return \NOUT\Soap\StructType\GetListIDMessFromFolder
     */
    public function setSort1(?\NOUT\Soap\StructType\SortType $sort1 = null): self
    {
        $this->Sort1 = $sort1;
        
        return $this;
    }
    /**
     * Get Sort2 value
     * @return \NOUT\Soap\StructType\SortType|null
     */
    public function getSort2(): ?\NOUT\Soap\StructType\SortType
    {
        return $this->Sort2;
    }
    /**
     * Set Sort2 value
     * @param \NOUT\Soap\StructType\SortType $sort2
     * @return \NOUT\Soap\StructType\GetListIDMessFromFolder
     */
    public function setSort2(?\NOUT\Soap\StructType\SortType $sort2 = null): self
    {
        $this->Sort2 = $sort2;
        
        return $this;
    }
    /**
     * Get Sort3 value
     * @return \NOUT\Soap\StructType\SortType|null
     */
    public function getSort3(): ?\NOUT\Soap\StructType\SortType
    {
        return $this->Sort3;
    }
    /**
     * Set Sort3 value
     * @param \NOUT\Soap\StructType\SortType $sort3
     * @return \NOUT\Soap\StructType\GetListIDMessFromFolder
     */
    public function setSort3(?\NOUT\Soap\StructType\SortType $sort3 = null): self
    {
        $this->Sort3 = $sort3;
        
        return $this;
    }
}
