<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for GetMailServiceStatusResponse StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class GetMailServiceStatusResponse extends AbstractStructBase
{
    /**
     * The UnRead
     * @var int|null
     */
    protected ?int $UnRead = null;
    /**
     * The Receive
     * @var int|null
     */
    protected ?int $Receive = null;
    /**
     * The UrgentUnRead
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int|null
     */
    protected ?int $UrgentUnRead = null;
    /**
     * The UrgentUnReadFromMax
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int|null
     */
    protected ?int $UrgentUnReadFromMax = null;
    /**
     * The UnReadFromMax
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int|null
     */
    protected ?int $UnReadFromMax = null;
    /**
     * The LastUnRead
     * @var \NOUT\Soap\StructType\LastUnReadType|null
     */
    protected ?\NOUT\Soap\StructType\LastUnReadType $LastUnRead = null;
    /**
     * Constructor method for GetMailServiceStatusResponse
     * @uses GetMailServiceStatusResponse::setUnRead()
     * @uses GetMailServiceStatusResponse::setReceive()
     * @uses GetMailServiceStatusResponse::setUrgentUnRead()
     * @uses GetMailServiceStatusResponse::setUrgentUnReadFromMax()
     * @uses GetMailServiceStatusResponse::setUnReadFromMax()
     * @uses GetMailServiceStatusResponse::setLastUnRead()
     * @param int $unRead
     * @param int $receive
     * @param int $urgentUnRead
     * @param int $urgentUnReadFromMax
     * @param int $unReadFromMax
     * @param \NOUT\Soap\StructType\LastUnReadType $lastUnRead
     */
    public function __construct(?int $unRead = null, ?int $receive = null, ?int $urgentUnRead = null, ?int $urgentUnReadFromMax = null, ?int $unReadFromMax = null, ?\NOUT\Soap\StructType\LastUnReadType $lastUnRead = null)
    {
        $this
            ->setUnRead($unRead)
            ->setReceive($receive)
            ->setUrgentUnRead($urgentUnRead)
            ->setUrgentUnReadFromMax($urgentUnReadFromMax)
            ->setUnReadFromMax($unReadFromMax)
            ->setLastUnRead($lastUnRead);
    }
    /**
     * Get UnRead value
     * @return int|null
     */
    public function getUnRead(): ?int
    {
        return $this->UnRead;
    }
    /**
     * Set UnRead value
     * @param int $unRead
     * @return \NOUT\Soap\StructType\GetMailServiceStatusResponse
     */
    public function setUnRead(?int $unRead = null): self
    {
        // validation for constraint: int
        if (!is_null($unRead) && !(is_int($unRead) || ctype_digit($unRead))) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($unRead, true), gettype($unRead)), __LINE__);
        }
        $this->UnRead = $unRead;
        
        return $this;
    }
    /**
     * Get Receive value
     * @return int|null
     */
    public function getReceive(): ?int
    {
        return $this->Receive;
    }
    /**
     * Set Receive value
     * @param int $receive
     * @return \NOUT\Soap\StructType\GetMailServiceStatusResponse
     */
    public function setReceive(?int $receive = null): self
    {
        // validation for constraint: int
        if (!is_null($receive) && !(is_int($receive) || ctype_digit($receive))) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($receive, true), gettype($receive)), __LINE__);
        }
        $this->Receive = $receive;
        
        return $this;
    }
    /**
     * Get UrgentUnRead value
     * @return int|null
     */
    public function getUrgentUnRead(): ?int
    {
        return $this->UrgentUnRead;
    }
    /**
     * Set UrgentUnRead value
     * @param int $urgentUnRead
     * @return \NOUT\Soap\StructType\GetMailServiceStatusResponse
     */
    public function setUrgentUnRead(?int $urgentUnRead = null): self
    {
        // validation for constraint: int
        if (!is_null($urgentUnRead) && !(is_int($urgentUnRead) || ctype_digit($urgentUnRead))) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($urgentUnRead, true), gettype($urgentUnRead)), __LINE__);
        }
        $this->UrgentUnRead = $urgentUnRead;
        
        return $this;
    }
    /**
     * Get UrgentUnReadFromMax value
     * @return int|null
     */
    public function getUrgentUnReadFromMax(): ?int
    {
        return $this->UrgentUnReadFromMax;
    }
    /**
     * Set UrgentUnReadFromMax value
     * @param int $urgentUnReadFromMax
     * @return \NOUT\Soap\StructType\GetMailServiceStatusResponse
     */
    public function setUrgentUnReadFromMax(?int $urgentUnReadFromMax = null): self
    {
        // validation for constraint: int
        if (!is_null($urgentUnReadFromMax) && !(is_int($urgentUnReadFromMax) || ctype_digit($urgentUnReadFromMax))) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($urgentUnReadFromMax, true), gettype($urgentUnReadFromMax)), __LINE__);
        }
        $this->UrgentUnReadFromMax = $urgentUnReadFromMax;
        
        return $this;
    }
    /**
     * Get UnReadFromMax value
     * @return int|null
     */
    public function getUnReadFromMax(): ?int
    {
        return $this->UnReadFromMax;
    }
    /**
     * Set UnReadFromMax value
     * @param int $unReadFromMax
     * @return \NOUT\Soap\StructType\GetMailServiceStatusResponse
     */
    public function setUnReadFromMax(?int $unReadFromMax = null): self
    {
        // validation for constraint: int
        if (!is_null($unReadFromMax) && !(is_int($unReadFromMax) || ctype_digit($unReadFromMax))) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($unReadFromMax, true), gettype($unReadFromMax)), __LINE__);
        }
        $this->UnReadFromMax = $unReadFromMax;
        
        return $this;
    }
    /**
     * Get LastUnRead value
     * @return \NOUT\Soap\StructType\LastUnReadType|null
     */
    public function getLastUnRead(): ?\NOUT\Soap\StructType\LastUnReadType
    {
        return $this->LastUnRead;
    }
    /**
     * Set LastUnRead value
     * @param \NOUT\Soap\StructType\LastUnReadType $lastUnRead
     * @return \NOUT\Soap\StructType\GetMailServiceStatusResponse
     */
    public function setLastUnRead(?\NOUT\Soap\StructType\LastUnReadType $lastUnRead = null): self
    {
        $this->LastUnRead = $lastUnRead;
        
        return $this;
    }
}
