<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for GetPlanningInfo StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class GetPlanningInfo extends AbstractStructBase
{
    /**
     * The Resource
     * @var string|null
     */
    protected ?string $Resource = null;
    /**
     * The StartTime
     * @var string|null
     */
    protected ?string $StartTime = null;
    /**
     * The EndTime
     * @var string|null
     */
    protected ?string $EndTime = null;
    /**
     * The Table
     * @var string|null
     */
    protected ?string $Table = null;
    /**
     * The ID
     * @var string|null
     */
    protected ?string $ID = null;
    /**
     * The ParamXML
     * @var string|null
     */
    protected ?string $ParamXML = null;
    /**
     * The VirtualParamList
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \NOUT\Soap\StructType\VirtualParamListType|null
     */
    protected ?\NOUT\Soap\StructType\VirtualParamListType $VirtualParamList = null;
    /**
     * Constructor method for GetPlanningInfo
     * @uses GetPlanningInfo::setResource()
     * @uses GetPlanningInfo::setStartTime()
     * @uses GetPlanningInfo::setEndTime()
     * @uses GetPlanningInfo::setTable()
     * @uses GetPlanningInfo::setID()
     * @uses GetPlanningInfo::setParamXML()
     * @uses GetPlanningInfo::setVirtualParamList()
     * @param string $resource
     * @param string $startTime
     * @param string $endTime
     * @param string $table
     * @param string $iD
     * @param string $paramXML
     * @param \NOUT\Soap\StructType\VirtualParamListType $virtualParamList
     */
    public function __construct(?string $resource = null, ?string $startTime = null, ?string $endTime = null, ?string $table = null, ?string $iD = null, ?string $paramXML = null, ?\NOUT\Soap\StructType\VirtualParamListType $virtualParamList = null)
    {
        $this
            ->setResource($resource)
            ->setStartTime($startTime)
            ->setEndTime($endTime)
            ->setTable($table)
            ->setID($iD)
            ->setParamXML($paramXML)
            ->setVirtualParamList($virtualParamList);
    }
    /**
     * Get Resource value
     * @return string|null
     */
    public function getResource(): ?string
    {
        return $this->Resource;
    }
    /**
     * Set Resource value
     * @param string $resource
     * @return \NOUT\Soap\StructType\GetPlanningInfo
     */
    public function setResource(?string $resource = null): self
    {
        // validation for constraint: string
        if (!is_null($resource) && !is_string($resource)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($resource, true), gettype($resource)), __LINE__);
        }
        $this->Resource = $resource;
        
        return $this;
    }
    /**
     * Get StartTime value
     * @return string|null
     */
    public function getStartTime(): ?string
    {
        return $this->StartTime;
    }
    /**
     * Set StartTime value
     * @param string $startTime
     * @return \NOUT\Soap\StructType\GetPlanningInfo
     */
    public function setStartTime(?string $startTime = null): self
    {
        // validation for constraint: string
        if (!is_null($startTime) && !is_string($startTime)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($startTime, true), gettype($startTime)), __LINE__);
        }
        $this->StartTime = $startTime;
        
        return $this;
    }
    /**
     * Get EndTime value
     * @return string|null
     */
    public function getEndTime(): ?string
    {
        return $this->EndTime;
    }
    /**
     * Set EndTime value
     * @param string $endTime
     * @return \NOUT\Soap\StructType\GetPlanningInfo
     */
    public function setEndTime(?string $endTime = null): self
    {
        // validation for constraint: string
        if (!is_null($endTime) && !is_string($endTime)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($endTime, true), gettype($endTime)), __LINE__);
        }
        $this->EndTime = $endTime;
        
        return $this;
    }
    /**
     * Get Table value
     * @return string|null
     */
    public function getTable(): ?string
    {
        return $this->Table;
    }
    /**
     * Set Table value
     * @param string $table
     * @return \NOUT\Soap\StructType\GetPlanningInfo
     */
    public function setTable(?string $table = null): self
    {
        // validation for constraint: string
        if (!is_null($table) && !is_string($table)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($table, true), gettype($table)), __LINE__);
        }
        $this->Table = $table;
        
        return $this;
    }
    /**
     * Get ID value
     * @return string|null
     */
    public function getID(): ?string
    {
        return $this->ID;
    }
    /**
     * Set ID value
     * @param string $iD
     * @return \NOUT\Soap\StructType\GetPlanningInfo
     */
    public function setID(?string $iD = null): self
    {
        // validation for constraint: string
        if (!is_null($iD) && !is_string($iD)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($iD, true), gettype($iD)), __LINE__);
        }
        $this->ID = $iD;
        
        return $this;
    }
    /**
     * Get ParamXML value
     * @return string|null
     */
    public function getParamXML(): ?string
    {
        return $this->ParamXML;
    }
    /**
     * Set ParamXML value
     * @param string $paramXML
     * @return \NOUT\Soap\StructType\GetPlanningInfo
     */
    public function setParamXML(?string $paramXML = null): self
    {
        // validation for constraint: string
        if (!is_null($paramXML) && !is_string($paramXML)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($paramXML, true), gettype($paramXML)), __LINE__);
        }
        $this->ParamXML = $paramXML;
        
        return $this;
    }
    /**
     * Get VirtualParamList value
     * @return \NOUT\Soap\StructType\VirtualParamListType|null
     */
    public function getVirtualParamList(): ?\NOUT\Soap\StructType\VirtualParamListType
    {
        return $this->VirtualParamList;
    }
    /**
     * Set VirtualParamList value
     * @param \NOUT\Soap\StructType\VirtualParamListType $virtualParamList
     * @return \NOUT\Soap\StructType\GetPlanningInfo
     */
    public function setVirtualParamList(?\NOUT\Soap\StructType\VirtualParamListType $virtualParamList = null): self
    {
        $this->VirtualParamList = $virtualParamList;
        
        return $this;
    }
}
