<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for GetTableChild StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class GetTableChild extends AbstractStructBase
{
    /**
     * The Table
     * @var string|null
     */
    protected ?string $Table = null;
    /**
     * The Recursive
     * @var string|null
     */
    protected ?string $Recursive = null;
    /**
     * The ReadOnly
     * @var string|null
     */
    protected ?string $ReadOnly = null;
    /**
     * Constructor method for GetTableChild
     * @uses GetTableChild::setTable()
     * @uses GetTableChild::setRecursive()
     * @uses GetTableChild::setReadOnly()
     * @param string $table
     * @param string $recursive
     * @param string $readOnly
     */
    public function __construct(?string $table = null, ?string $recursive = null, ?string $readOnly = null)
    {
        $this
            ->setTable($table)
            ->setRecursive($recursive)
            ->setReadOnly($readOnly);
    }
    /**
     * Get Table value
     * @return string|null
     */
    public function getTable(): ?string
    {
        return $this->Table;
    }
    /**
     * Set Table value
     * @param string $table
     * @return \NOUT\Soap\StructType\GetTableChild
     */
    public function setTable(?string $table = null): self
    {
        // validation for constraint: string
        if (!is_null($table) && !is_string($table)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($table, true), gettype($table)), __LINE__);
        }
        $this->Table = $table;
        
        return $this;
    }
    /**
     * Get Recursive value
     * @return string|null
     */
    public function getRecursive(): ?string
    {
        return $this->Recursive;
    }
    /**
     * Set Recursive value
     * @param string $recursive
     * @return \NOUT\Soap\StructType\GetTableChild
     */
    public function setRecursive(?string $recursive = null): self
    {
        // validation for constraint: string
        if (!is_null($recursive) && !is_string($recursive)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($recursive, true), gettype($recursive)), __LINE__);
        }
        $this->Recursive = $recursive;
        
        return $this;
    }
    /**
     * Get ReadOnly value
     * @return string|null
     */
    public function getReadOnly(): ?string
    {
        return $this->ReadOnly;
    }
    /**
     * Set ReadOnly value
     * @param string $readOnly
     * @return \NOUT\Soap\StructType\GetTableChild
     */
    public function setReadOnly(?string $readOnly = null): self
    {
        // validation for constraint: string
        if (!is_null($readOnly) && !is_string($readOnly)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($readOnly, true), gettype($readOnly)), __LINE__);
        }
        $this->ReadOnly = $readOnly;
        
        return $this;
    }
}
