<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for GetTokenSessionResponse StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class GetTokenSessionResponse extends AbstractStructBase
{
    /**
     * The SessionToken
     * @var string|null
     */
    protected ?string $SessionToken = null;
    /**
     * Constructor method for GetTokenSessionResponse
     * @uses GetTokenSessionResponse::setSessionToken()
     * @param string $sessionToken
     */
    public function __construct(?string $sessionToken = null)
    {
        $this
            ->setSessionToken($sessionToken);
    }
    /**
     * Get SessionToken value
     * @return string|null
     */
    public function getSessionToken(): ?string
    {
        return $this->SessionToken;
    }
    /**
     * Set SessionToken value
     * @param string $sessionToken
     * @return \NOUT\Soap\StructType\GetTokenSessionResponse
     */
    public function setSessionToken(?string $sessionToken = null): self
    {
        // validation for constraint: string
        if (!is_null($sessionToken) && !is_string($sessionToken)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sessionToken, true), gettype($sessionToken)), __LINE__);
        }
        $this->SessionToken = $sessionToken;
        
        return $this;
    }
}
