<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for GlobalEvents StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class GlobalEvents extends AbstractStructBase
{
    /**
     * The ActionsToRefresh
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string|null
     */
    protected ?string $ActionsToRefresh = null;
    /**
     * The ColumnsToRefresh
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \NOUT\Soap\StructType\ColumnsToRefresh[]
     */
    protected ?array $ColumnsToRefresh = null;
    /**
     * Constructor method for GlobalEvents
     * @uses GlobalEvents::setActionsToRefresh()
     * @uses GlobalEvents::setColumnsToRefresh()
     * @param string $actionsToRefresh
     * @param \NOUT\Soap\StructType\ColumnsToRefresh[] $columnsToRefresh
     */
    public function __construct(?string $actionsToRefresh = null, ?array $columnsToRefresh = null)
    {
        $this
            ->setActionsToRefresh($actionsToRefresh)
            ->setColumnsToRefresh($columnsToRefresh);
    }
    /**
     * Get ActionsToRefresh value
     * @return string|null
     */
    public function getActionsToRefresh(): ?string
    {
        return $this->ActionsToRefresh;
    }
    /**
     * Set ActionsToRefresh value
     * @param string $actionsToRefresh
     * @return \NOUT\Soap\StructType\GlobalEvents
     */
    public function setActionsToRefresh(?string $actionsToRefresh = null): self
    {
        // validation for constraint: string
        if (!is_null($actionsToRefresh) && !is_string($actionsToRefresh)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($actionsToRefresh, true), gettype($actionsToRefresh)), __LINE__);
        }
        $this->ActionsToRefresh = $actionsToRefresh;
        
        return $this;
    }
    /**
     * Get ColumnsToRefresh value
     * @return \NOUT\Soap\StructType\ColumnsToRefresh[]
     */
    public function getColumnsToRefresh(): ?array
    {
        return $this->ColumnsToRefresh;
    }
    /**
     * This method is responsible for validating the value(s) passed to the setColumnsToRefresh method
     * This method is willingly generated in order to preserve the one-line inline validation within the setColumnsToRefresh method
     * This has to validate that each item contained by the array match the itemType constraint
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateColumnsToRefreshForArrayConstraintFromSetColumnsToRefresh(?array $values = []): string
    {
        if (!is_array($values)) {
            return '';
        }
        $message = '';
        $invalidValues = [];
        foreach ($values as $globalEventsColumnsToRefreshItem) {
            // validation for constraint: itemType
            if (!$globalEventsColumnsToRefreshItem instanceof \NOUT\Soap\StructType\ColumnsToRefresh) {
                $invalidValues[] = is_object($globalEventsColumnsToRefreshItem) ? get_class($globalEventsColumnsToRefreshItem) : sprintf('%s(%s)', gettype($globalEventsColumnsToRefreshItem), var_export($globalEventsColumnsToRefreshItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ColumnsToRefresh property can only contain items of type \NOUT\Soap\StructType\ColumnsToRefresh, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        
        return $message;
    }
    /**
     * Set ColumnsToRefresh value
     * @throws InvalidArgumentException
     * @param \NOUT\Soap\StructType\ColumnsToRefresh[] $columnsToRefresh
     * @return \NOUT\Soap\StructType\GlobalEvents
     */
    public function setColumnsToRefresh(?array $columnsToRefresh = null): self
    {
        // validation for constraint: array
        if ('' !== ($columnsToRefreshArrayErrorMessage = self::validateColumnsToRefreshForArrayConstraintFromSetColumnsToRefresh($columnsToRefresh))) {
            throw new InvalidArgumentException($columnsToRefreshArrayErrorMessage, __LINE__);
        }
        $this->ColumnsToRefresh = $columnsToRefresh;
        
        return $this;
    }
    /**
     * Add item to ColumnsToRefresh value
     * @throws InvalidArgumentException
     * @param \NOUT\Soap\StructType\ColumnsToRefresh $item
     * @return \NOUT\Soap\StructType\GlobalEvents
     */
    public function addToColumnsToRefresh(\NOUT\Soap\StructType\ColumnsToRefresh $item): self
    {
        // validation for constraint: itemType
        if (!$item instanceof \NOUT\Soap\StructType\ColumnsToRefresh) {
            throw new InvalidArgumentException(sprintf('The ColumnsToRefresh property can only contain items of type \NOUT\Soap\StructType\ColumnsToRefresh, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ColumnsToRefresh[] = $item;
        
        return $this;
    }
}
