<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for IDIHMToClose StructType
 * Meta information extracted from the WSDL
 * - type: tns:IDIHMToClose
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class IDIHMToClose extends AbstractStructBase
{
    /**
     * The IDIHM
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var string[]
     */
    protected ?array $IDIHM = null;
    /**
     * Constructor method for IDIHMToClose
     * @uses IDIHMToClose::setIDIHM()
     * @param string[] $iDIHM
     */
    public function __construct(?array $iDIHM = null)
    {
        $this
            ->setIDIHM($iDIHM);
    }
    /**
     * Get IDIHM value
     * @return string[]
     */
    public function getIDIHM(): ?array
    {
        return $this->IDIHM;
    }
    /**
     * This method is responsible for validating the value(s) passed to the setIDIHM method
     * This method is willingly generated in order to preserve the one-line inline validation within the setIDIHM method
     * This has to validate that each item contained by the array match the itemType constraint
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateIDIHMForArrayConstraintFromSetIDIHM(?array $values = []): string
    {
        if (!is_array($values)) {
            return '';
        }
        $message = '';
        $invalidValues = [];
        foreach ($values as $iDIHMToCloseIDIHMItem) {
            // validation for constraint: itemType
            if (!is_string($iDIHMToCloseIDIHMItem)) {
                $invalidValues[] = is_object($iDIHMToCloseIDIHMItem) ? get_class($iDIHMToCloseIDIHMItem) : sprintf('%s(%s)', gettype($iDIHMToCloseIDIHMItem), var_export($iDIHMToCloseIDIHMItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The IDIHM property can only contain items of type string, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        
        return $message;
    }
    /**
     * Set IDIHM value
     * @throws InvalidArgumentException
     * @param string[] $iDIHM
     * @return \NOUT\Soap\StructType\IDIHMToClose
     */
    public function setIDIHM(?array $iDIHM = null): self
    {
        // validation for constraint: array
        if ('' !== ($iDIHMArrayErrorMessage = self::validateIDIHMForArrayConstraintFromSetIDIHM($iDIHM))) {
            throw new InvalidArgumentException($iDIHMArrayErrorMessage, __LINE__);
        }
        $this->IDIHM = $iDIHM;
        
        return $this;
    }
    /**
     * Add item to IDIHM value
     * @throws InvalidArgumentException
     * @param string $item
     * @return \NOUT\Soap\StructType\IDIHMToClose
     */
    public function addToIDIHM(string $item): self
    {
        // validation for constraint: itemType
        if (!is_string($item)) {
            throw new InvalidArgumentException(sprintf('The IDIHM property can only contain items of type string, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->IDIHM[] = $item;
        
        return $this;
    }
}
