<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for InitRecordFromMessage StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class InitRecordFromMessage extends AbstractStructBase
{
    /**
     * The Table
     * @var string|null
     */
    protected ?string $Table = null;
    /**
     * The Record
     * @var string|null
     */
    protected ?string $Record = null;
    /**
     * The IDMessage
     * @var string|null
     */
    protected ?string $IDMessage = null;
    /**
     * Constructor method for InitRecordFromMessage
     * @uses InitRecordFromMessage::setTable()
     * @uses InitRecordFromMessage::setRecord()
     * @uses InitRecordFromMessage::setIDMessage()
     * @param string $table
     * @param string $record
     * @param string $iDMessage
     */
    public function __construct(?string $table = null, ?string $record = null, ?string $iDMessage = null)
    {
        $this
            ->setTable($table)
            ->setRecord($record)
            ->setIDMessage($iDMessage);
    }
    /**
     * Get Table value
     * @return string|null
     */
    public function getTable(): ?string
    {
        return $this->Table;
    }
    /**
     * Set Table value
     * @param string $table
     * @return \NOUT\Soap\StructType\InitRecordFromMessage
     */
    public function setTable(?string $table = null): self
    {
        // validation for constraint: string
        if (!is_null($table) && !is_string($table)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($table, true), gettype($table)), __LINE__);
        }
        $this->Table = $table;
        
        return $this;
    }
    /**
     * Get Record value
     * @return string|null
     */
    public function getRecord(): ?string
    {
        return $this->Record;
    }
    /**
     * Set Record value
     * @param string $record
     * @return \NOUT\Soap\StructType\InitRecordFromMessage
     */
    public function setRecord(?string $record = null): self
    {
        // validation for constraint: string
        if (!is_null($record) && !is_string($record)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($record, true), gettype($record)), __LINE__);
        }
        $this->Record = $record;
        
        return $this;
    }
    /**
     * Get IDMessage value
     * @return string|null
     */
    public function getIDMessage(): ?string
    {
        return $this->IDMessage;
    }
    /**
     * Set IDMessage value
     * @param string $iDMessage
     * @return \NOUT\Soap\StructType\InitRecordFromMessage
     */
    public function setIDMessage(?string $iDMessage = null): self
    {
        // validation for constraint: string
        if (!is_null($iDMessage) && !is_string($iDMessage)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($iDMessage, true), gettype($iDMessage)), __LINE__);
        }
        $this->IDMessage = $iDMessage;
        
        return $this;
    }
}
