<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for LanguageCodeList StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class LanguageCodeList extends AbstractStructBase
{
    /**
     * The LanguageCode
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var int[]
     */
    protected ?array $LanguageCode = null;
    /**
     * Constructor method for LanguageCodeList
     * @uses LanguageCodeList::setLanguageCode()
     * @param int[] $languageCode
     */
    public function __construct(?array $languageCode = null)
    {
        $this
            ->setLanguageCode($languageCode);
    }
    /**
     * Get LanguageCode value
     * @return int[]
     */
    public function getLanguageCode(): ?array
    {
        return $this->LanguageCode;
    }
    /**
     * This method is responsible for validating the value(s) passed to the setLanguageCode method
     * This method is willingly generated in order to preserve the one-line inline validation within the setLanguageCode method
     * This has to validate that each item contained by the array match the itemType constraint
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateLanguageCodeForArrayConstraintFromSetLanguageCode(?array $values = []): string
    {
        if (!is_array($values)) {
            return '';
        }
        $message = '';
        $invalidValues = [];
        foreach ($values as $languageCodeListLanguageCodeItem) {
            // validation for constraint: itemType
            if (!(is_int($languageCodeListLanguageCodeItem) || ctype_digit($languageCodeListLanguageCodeItem))) {
                $invalidValues[] = is_object($languageCodeListLanguageCodeItem) ? get_class($languageCodeListLanguageCodeItem) : sprintf('%s(%s)', gettype($languageCodeListLanguageCodeItem), var_export($languageCodeListLanguageCodeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The LanguageCode property can only contain items of type int, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        
        return $message;
    }
    /**
     * Set LanguageCode value
     * @throws InvalidArgumentException
     * @param int[] $languageCode
     * @return \NOUT\Soap\StructType\LanguageCodeList
     */
    public function setLanguageCode(?array $languageCode = null): self
    {
        // validation for constraint: array
        if ('' !== ($languageCodeArrayErrorMessage = self::validateLanguageCodeForArrayConstraintFromSetLanguageCode($languageCode))) {
            throw new InvalidArgumentException($languageCodeArrayErrorMessage, __LINE__);
        }
        $this->LanguageCode = $languageCode;
        
        return $this;
    }
    /**
     * Add item to LanguageCode value
     * @throws InvalidArgumentException
     * @param int $item
     * @return \NOUT\Soap\StructType\LanguageCodeList
     */
    public function addToLanguageCode(int $item): self
    {
        // validation for constraint: itemType
        if (!(is_int($item) || ctype_digit($item))) {
            throw new InvalidArgumentException(sprintf('The LanguageCode property can only contain items of type int, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->LanguageCode[] = $item;
        
        return $this;
    }
}
