<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for Merge StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class Merge extends AbstractStructBase
{
    /**
     * The Table
     * @var string|null
     */
    protected ?string $Table = null;
    /**
     * The ElemSrc
     * @var string|null
     */
    protected ?string $ElemSrc = null;
    /**
     * The ElemDest
     * @var string|null
     */
    protected ?string $ElemDest = null;
    /**
     * Constructor method for Merge
     * @uses Merge::setTable()
     * @uses Merge::setElemSrc()
     * @uses Merge::setElemDest()
     * @param string $table
     * @param string $elemSrc
     * @param string $elemDest
     */
    public function __construct(?string $table = null, ?string $elemSrc = null, ?string $elemDest = null)
    {
        $this
            ->setTable($table)
            ->setElemSrc($elemSrc)
            ->setElemDest($elemDest);
    }
    /**
     * Get Table value
     * @return string|null
     */
    public function getTable(): ?string
    {
        return $this->Table;
    }
    /**
     * Set Table value
     * @param string $table
     * @return \NOUT\Soap\StructType\Merge
     */
    public function setTable(?string $table = null): self
    {
        // validation for constraint: string
        if (!is_null($table) && !is_string($table)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($table, true), gettype($table)), __LINE__);
        }
        $this->Table = $table;
        
        return $this;
    }
    /**
     * Get ElemSrc value
     * @return string|null
     */
    public function getElemSrc(): ?string
    {
        return $this->ElemSrc;
    }
    /**
     * Set ElemSrc value
     * @param string $elemSrc
     * @return \NOUT\Soap\StructType\Merge
     */
    public function setElemSrc(?string $elemSrc = null): self
    {
        // validation for constraint: string
        if (!is_null($elemSrc) && !is_string($elemSrc)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($elemSrc, true), gettype($elemSrc)), __LINE__);
        }
        $this->ElemSrc = $elemSrc;
        
        return $this;
    }
    /**
     * Get ElemDest value
     * @return string|null
     */
    public function getElemDest(): ?string
    {
        return $this->ElemDest;
    }
    /**
     * Set ElemDest value
     * @param string $elemDest
     * @return \NOUT\Soap\StructType\Merge
     */
    public function setElemDest(?string $elemDest = null): self
    {
        // validation for constraint: string
        if (!is_null($elemDest) && !is_string($elemDest)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($elemDest, true), gettype($elemDest)), __LINE__);
        }
        $this->ElemDest = $elemDest;
        
        return $this;
    }
}
