<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for PlanningFilter StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class PlanningFilter extends AbstractStructBase
{
    /**
     * The Resource
     * @var string|null
     */
    protected ?string $Resource = null;
    /**
     * The Table
     * @var string|null
     */
    protected ?string $Table = null;
    /**
     * The StartTime
     * @var string|null
     */
    protected ?string $StartTime = null;
    /**
     * The EndTime
     * @var string|null
     */
    protected ?string $EndTime = null;
    /**
     * Constructor method for PlanningFilter
     * @uses PlanningFilter::setResource()
     * @uses PlanningFilter::setTable()
     * @uses PlanningFilter::setStartTime()
     * @uses PlanningFilter::setEndTime()
     * @param string $resource
     * @param string $table
     * @param string $startTime
     * @param string $endTime
     */
    public function __construct(?string $resource = null, ?string $table = null, ?string $startTime = null, ?string $endTime = null)
    {
        $this
            ->setResource($resource)
            ->setTable($table)
            ->setStartTime($startTime)
            ->setEndTime($endTime);
    }
    /**
     * Get Resource value
     * @return string|null
     */
    public function getResource(): ?string
    {
        return $this->Resource;
    }
    /**
     * Set Resource value
     * @param string $resource
     * @return \NOUT\Soap\StructType\PlanningFilter
     */
    public function setResource(?string $resource = null): self
    {
        // validation for constraint: string
        if (!is_null($resource) && !is_string($resource)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($resource, true), gettype($resource)), __LINE__);
        }
        $this->Resource = $resource;
        
        return $this;
    }
    /**
     * Get Table value
     * @return string|null
     */
    public function getTable(): ?string
    {
        return $this->Table;
    }
    /**
     * Set Table value
     * @param string $table
     * @return \NOUT\Soap\StructType\PlanningFilter
     */
    public function setTable(?string $table = null): self
    {
        // validation for constraint: string
        if (!is_null($table) && !is_string($table)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($table, true), gettype($table)), __LINE__);
        }
        $this->Table = $table;
        
        return $this;
    }
    /**
     * Get StartTime value
     * @return string|null
     */
    public function getStartTime(): ?string
    {
        return $this->StartTime;
    }
    /**
     * Set StartTime value
     * @param string $startTime
     * @return \NOUT\Soap\StructType\PlanningFilter
     */
    public function setStartTime(?string $startTime = null): self
    {
        // validation for constraint: string
        if (!is_null($startTime) && !is_string($startTime)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($startTime, true), gettype($startTime)), __LINE__);
        }
        $this->StartTime = $startTime;
        
        return $this;
    }
    /**
     * Get EndTime value
     * @return string|null
     */
    public function getEndTime(): ?string
    {
        return $this->EndTime;
    }
    /**
     * Set EndTime value
     * @param string $endTime
     * @return \NOUT\Soap\StructType\PlanningFilter
     */
    public function setEndTime(?string $endTime = null): self
    {
        // validation for constraint: string
        if (!is_null($endTime) && !is_string($endTime)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($endTime, true), gettype($endTime)), __LINE__);
        }
        $this->EndTime = $endTime;
        
        return $this;
    }
}
