<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for RequestHeader StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class RequestHeader extends AbstractStructBase
{
    /**
     * The _
     * @var string|null
     */
    protected ?string $_ = null;
    /**
     * The title
     * @var string|null
     */
    protected ?string $title = null;
    /**
     * The form
     * @var string|null
     */
    protected ?string $form = null;
    /**
     * Constructor method for RequestHeader
     * @uses RequestHeader::set_()
     * @uses RequestHeader::setTitle()
     * @uses RequestHeader::setForm()
     * @param string $_
     * @param string $title
     * @param string $form
     */
    public function __construct(?string $_ = null, ?string $title = null, ?string $form = null)
    {
        $this
            ->set_($_)
            ->setTitle($title)
            ->setForm($form);
    }
    /**
     * Get _ value
     * @return string|null
     */
    public function get_(): ?string
    {
        return $this->_;
    }
    /**
     * Set _ value
     * @param string $_
     * @return \NOUT\Soap\StructType\RequestHeader
     */
    public function set_(?string $_ = null): self
    {
        // validation for constraint: string
        if (!is_null($_) && !is_string($_)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($_, true), gettype($_)), __LINE__);
        }
        $this->_ = $_;
        
        return $this;
    }
    /**
     * Get title value
     * @return string|null
     */
    public function getTitle(): ?string
    {
        return $this->title;
    }
    /**
     * Set title value
     * @param string $title
     * @return \NOUT\Soap\StructType\RequestHeader
     */
    public function setTitle(?string $title = null): self
    {
        // validation for constraint: string
        if (!is_null($title) && !is_string($title)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($title, true), gettype($title)), __LINE__);
        }
        $this->title = $title;
        
        return $this;
    }
    /**
     * Get form value
     * @return string|null
     */
    public function getForm(): ?string
    {
        return $this->form;
    }
    /**
     * Set form value
     * @param string $form
     * @return \NOUT\Soap\StructType\RequestHeader
     */
    public function setForm(?string $form = null): self
    {
        // validation for constraint: string
        if (!is_null($form) && !is_string($form)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($form, true), gettype($form)), __LINE__);
        }
        $this->form = $form;
        
        return $this;
    }
}
