<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for RequestMessage StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class RequestMessage extends AbstractStructBase
{
    /**
     * The StartDate
     * @var string|null
     */
    protected ?string $StartDate = null;
    /**
     * The EndDate
     * @var string|null
     */
    protected ?string $EndDate = null;
    /**
     * The Filter
     * @var \NOUT\Soap\StructType\FilterType|null
     */
    protected ?\NOUT\Soap\StructType\FilterType $Filter = null;
    /**
     * The UserMessagerie
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string|null
     */
    protected ?string $UserMessagerie = null;
    /**
     * The SpecialParamList
     * @var \NOUT\Soap\StructType\SpecialParamListType|null
     */
    protected ?\NOUT\Soap\StructType\SpecialParamListType $SpecialParamList = null;
    /**
     * Constructor method for RequestMessage
     * @uses RequestMessage::setStartDate()
     * @uses RequestMessage::setEndDate()
     * @uses RequestMessage::setFilter()
     * @uses RequestMessage::setUserMessagerie()
     * @uses RequestMessage::setSpecialParamList()
     * @param string $startDate
     * @param string $endDate
     * @param \NOUT\Soap\StructType\FilterType $filter
     * @param string $userMessagerie
     * @param \NOUT\Soap\StructType\SpecialParamListType $specialParamList
     */
    public function __construct(?string $startDate = null, ?string $endDate = null, ?\NOUT\Soap\StructType\FilterType $filter = null, ?string $userMessagerie = null, ?\NOUT\Soap\StructType\SpecialParamListType $specialParamList = null)
    {
        $this
            ->setStartDate($startDate)
            ->setEndDate($endDate)
            ->setFilter($filter)
            ->setUserMessagerie($userMessagerie)
            ->setSpecialParamList($specialParamList);
    }
    /**
     * Get StartDate value
     * @return string|null
     */
    public function getStartDate(): ?string
    {
        return $this->StartDate;
    }
    /**
     * Set StartDate value
     * @param string $startDate
     * @return \NOUT\Soap\StructType\RequestMessage
     */
    public function setStartDate(?string $startDate = null): self
    {
        // validation for constraint: string
        if (!is_null($startDate) && !is_string($startDate)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($startDate, true), gettype($startDate)), __LINE__);
        }
        $this->StartDate = $startDate;
        
        return $this;
    }
    /**
     * Get EndDate value
     * @return string|null
     */
    public function getEndDate(): ?string
    {
        return $this->EndDate;
    }
    /**
     * Set EndDate value
     * @param string $endDate
     * @return \NOUT\Soap\StructType\RequestMessage
     */
    public function setEndDate(?string $endDate = null): self
    {
        // validation for constraint: string
        if (!is_null($endDate) && !is_string($endDate)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($endDate, true), gettype($endDate)), __LINE__);
        }
        $this->EndDate = $endDate;
        
        return $this;
    }
    /**
     * Get Filter value
     * @return \NOUT\Soap\StructType\FilterType|null
     */
    public function getFilter(): ?\NOUT\Soap\StructType\FilterType
    {
        return $this->Filter;
    }
    /**
     * Set Filter value
     * @param \NOUT\Soap\StructType\FilterType $filter
     * @return \NOUT\Soap\StructType\RequestMessage
     */
    public function setFilter(?\NOUT\Soap\StructType\FilterType $filter = null): self
    {
        $this->Filter = $filter;
        
        return $this;
    }
    /**
     * Get UserMessagerie value
     * @return string|null
     */
    public function getUserMessagerie(): ?string
    {
        return $this->UserMessagerie;
    }
    /**
     * Set UserMessagerie value
     * @param string $userMessagerie
     * @return \NOUT\Soap\StructType\RequestMessage
     */
    public function setUserMessagerie(?string $userMessagerie = null): self
    {
        // validation for constraint: string
        if (!is_null($userMessagerie) && !is_string($userMessagerie)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($userMessagerie, true), gettype($userMessagerie)), __LINE__);
        }
        $this->UserMessagerie = $userMessagerie;
        
        return $this;
    }
    /**
     * Get SpecialParamList value
     * @return \NOUT\Soap\StructType\SpecialParamListType|null
     */
    public function getSpecialParamList(): ?\NOUT\Soap\StructType\SpecialParamListType
    {
        return $this->SpecialParamList;
    }
    /**
     * Set SpecialParamList value
     * @param \NOUT\Soap\StructType\SpecialParamListType $specialParamList
     * @return \NOUT\Soap\StructType\RequestMessage
     */
    public function setSpecialParamList(?\NOUT\Soap\StructType\SpecialParamListType $specialParamList = null): self
    {
        $this->SpecialParamList = $specialParamList;
        
        return $this;
    }
}
