<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for ResetPasswordFailed StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class ResetPasswordFailed extends AbstractStructBase
{
    /**
     * The Login
     * @var string|null
     */
    protected ?string $Login = null;
    /**
     * Constructor method for ResetPasswordFailed
     * @uses ResetPasswordFailed::setLogin()
     * @param string $login
     */
    public function __construct(?string $login = null)
    {
        $this
            ->setLogin($login);
    }
    /**
     * Get Login value
     * @return string|null
     */
    public function getLogin(): ?string
    {
        return $this->Login;
    }
    /**
     * Set Login value
     * @param string $login
     * @return \NOUT\Soap\StructType\ResetPasswordFailed
     */
    public function setLogin(?string $login = null): self
    {
        // validation for constraint: string
        if (!is_null($login) && !is_string($login)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($login, true), gettype($login)), __LINE__);
        }
        $this->Login = $login;
        
        return $this;
    }
}
