<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for SelectChoice StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class SelectChoice extends AbstractStructBase
{
    /**
     * The Choice
     * @var string|null
     */
    protected ?string $Choice = null;
    /**
     * Constructor method for SelectChoice
     * @uses SelectChoice::setChoice()
     * @param string $choice
     */
    public function __construct(?string $choice = null)
    {
        $this
            ->setChoice($choice);
    }
    /**
     * Get Choice value
     * @return string|null
     */
    public function getChoice(): ?string
    {
        return $this->Choice;
    }
    /**
     * Set Choice value
     * @param string $choice
     * @return \NOUT\Soap\StructType\SelectChoice
     */
    public function setChoice(?string $choice = null): self
    {
        // validation for constraint: string
        if (!is_null($choice) && !is_string($choice)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($choice, true), gettype($choice)), __LINE__);
        }
        $this->Choice = $choice;
        
        return $this;
    }
}
