<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for SelectedItemsType StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class SelectedItemsType extends AbstractStructBase
{
    /**
     * The _
     * @var string|null
     */
    protected ?string $_ = null;
    /**
     * The column
     * Meta information extracted from the WSDL
     * - use: optional
     * @var string|null
     */
    protected ?string $column = null;
    /**
     * Constructor method for SelectedItemsType
     * @uses SelectedItemsType::set_()
     * @uses SelectedItemsType::setColumn()
     * @param string $_
     * @param string $column
     */
    public function __construct(?string $_ = null, ?string $column = null)
    {
        $this
            ->set_($_)
            ->setColumn($column);
    }
    /**
     * Get _ value
     * @return string|null
     */
    public function get_(): ?string
    {
        return $this->_;
    }
    /**
     * Set _ value
     * @param string $_
     * @return \NOUT\Soap\StructType\SelectedItemsType
     */
    public function set_(?string $_ = null): self
    {
        // validation for constraint: string
        if (!is_null($_) && !is_string($_)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($_, true), gettype($_)), __LINE__);
        }
        $this->_ = $_;
        
        return $this;
    }
    /**
     * Get column value
     * @return string|null
     */
    public function getColumn(): ?string
    {
        return $this->column;
    }
    /**
     * Set column value
     * @param string $column
     * @return \NOUT\Soap\StructType\SelectedItemsType
     */
    public function setColumn(?string $column = null): self
    {
        // validation for constraint: string
        if (!is_null($column) && !is_string($column)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($column, true), gettype($column)), __LINE__);
        }
        $this->column = $column;
        
        return $this;
    }
}
