<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for SpecialParamListType StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class SpecialParamListType extends AbstractStructBase
{
    /**
     * The First
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int|null
     */
    protected ?int $First = null;
    /**
     * The Length
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int|null
     */
    protected ?int $Length = null;
    /**
     * The WithBreakRow
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int|null
     */
    protected ?int $WithBreakRow = null;
    /**
     * The WithEndCalculation
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int|null
     */
    protected ?int $WithEndCalculation = null;
    /**
     * The ChangePage
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int|null
     */
    protected ?int $ChangePage = null;
    /**
     * The Sort1
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \NOUT\Soap\StructType\SortType|null
     */
    protected ?\NOUT\Soap\StructType\SortType $Sort1 = null;
    /**
     * The Sort2
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \NOUT\Soap\StructType\SortType|null
     */
    protected ?\NOUT\Soap\StructType\SortType $Sort2 = null;
    /**
     * The Sort3
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \NOUT\Soap\StructType\SortType|null
     */
    protected ?\NOUT\Soap\StructType\SortType $Sort3 = null;
    /**
     * The ItemTreeParent
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string|null
     */
    protected ?string $ItemTreeParent = null;
    /**
     * The OnDemandColumns
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string|null
     */
    protected ?string $OnDemandColumns = null;
    /**
     * Constructor method for SpecialParamListType
     * @uses SpecialParamListType::setFirst()
     * @uses SpecialParamListType::setLength()
     * @uses SpecialParamListType::setWithBreakRow()
     * @uses SpecialParamListType::setWithEndCalculation()
     * @uses SpecialParamListType::setChangePage()
     * @uses SpecialParamListType::setSort1()
     * @uses SpecialParamListType::setSort2()
     * @uses SpecialParamListType::setSort3()
     * @uses SpecialParamListType::setItemTreeParent()
     * @uses SpecialParamListType::setOnDemandColumns()
     * @param int $first
     * @param int $length
     * @param int $withBreakRow
     * @param int $withEndCalculation
     * @param int $changePage
     * @param \NOUT\Soap\StructType\SortType $sort1
     * @param \NOUT\Soap\StructType\SortType $sort2
     * @param \NOUT\Soap\StructType\SortType $sort3
     * @param string $itemTreeParent
     * @param string $onDemandColumns
     */
    public function __construct(?int $first = null, ?int $length = null, ?int $withBreakRow = null, ?int $withEndCalculation = null, ?int $changePage = null, ?\NOUT\Soap\StructType\SortType $sort1 = null, ?\NOUT\Soap\StructType\SortType $sort2 = null, ?\NOUT\Soap\StructType\SortType $sort3 = null, ?string $itemTreeParent = null, ?string $onDemandColumns = null)
    {
        $this
            ->setFirst($first)
            ->setLength($length)
            ->setWithBreakRow($withBreakRow)
            ->setWithEndCalculation($withEndCalculation)
            ->setChangePage($changePage)
            ->setSort1($sort1)
            ->setSort2($sort2)
            ->setSort3($sort3)
            ->setItemTreeParent($itemTreeParent)
            ->setOnDemandColumns($onDemandColumns);
    }
    /**
     * Get First value
     * @return int|null
     */
    public function getFirst(): ?int
    {
        return $this->First;
    }
    /**
     * Set First value
     * @param int $first
     * @return \NOUT\Soap\StructType\SpecialParamListType
     */
    public function setFirst(?int $first = null): self
    {
        // validation for constraint: int
        if (!is_null($first) && !(is_int($first) || ctype_digit($first))) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($first, true), gettype($first)), __LINE__);
        }
        $this->First = $first;
        
        return $this;
    }
    /**
     * Get Length value
     * @return int|null
     */
    public function getLength(): ?int
    {
        return $this->Length;
    }
    /**
     * Set Length value
     * @param int $length
     * @return \NOUT\Soap\StructType\SpecialParamListType
     */
    public function setLength(?int $length = null): self
    {
        // validation for constraint: int
        if (!is_null($length) && !(is_int($length) || ctype_digit($length))) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($length, true), gettype($length)), __LINE__);
        }
        $this->Length = $length;
        
        return $this;
    }
    /**
     * Get WithBreakRow value
     * @return int|null
     */
    public function getWithBreakRow(): ?int
    {
        return $this->WithBreakRow;
    }
    /**
     * Set WithBreakRow value
     * @param int $withBreakRow
     * @return \NOUT\Soap\StructType\SpecialParamListType
     */
    public function setWithBreakRow(?int $withBreakRow = null): self
    {
        // validation for constraint: int
        if (!is_null($withBreakRow) && !(is_int($withBreakRow) || ctype_digit($withBreakRow))) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($withBreakRow, true), gettype($withBreakRow)), __LINE__);
        }
        $this->WithBreakRow = $withBreakRow;
        
        return $this;
    }
    /**
     * Get WithEndCalculation value
     * @return int|null
     */
    public function getWithEndCalculation(): ?int
    {
        return $this->WithEndCalculation;
    }
    /**
     * Set WithEndCalculation value
     * @param int $withEndCalculation
     * @return \NOUT\Soap\StructType\SpecialParamListType
     */
    public function setWithEndCalculation(?int $withEndCalculation = null): self
    {
        // validation for constraint: int
        if (!is_null($withEndCalculation) && !(is_int($withEndCalculation) || ctype_digit($withEndCalculation))) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($withEndCalculation, true), gettype($withEndCalculation)), __LINE__);
        }
        $this->WithEndCalculation = $withEndCalculation;
        
        return $this;
    }
    /**
     * Get ChangePage value
     * @return int|null
     */
    public function getChangePage(): ?int
    {
        return $this->ChangePage;
    }
    /**
     * Set ChangePage value
     * @param int $changePage
     * @return \NOUT\Soap\StructType\SpecialParamListType
     */
    public function setChangePage(?int $changePage = null): self
    {
        // validation for constraint: int
        if (!is_null($changePage) && !(is_int($changePage) || ctype_digit($changePage))) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($changePage, true), gettype($changePage)), __LINE__);
        }
        $this->ChangePage = $changePage;
        
        return $this;
    }
    /**
     * Get Sort1 value
     * @return \NOUT\Soap\StructType\SortType|null
     */
    public function getSort1(): ?\NOUT\Soap\StructType\SortType
    {
        return $this->Sort1;
    }
    /**
     * Set Sort1 value
     * @param \NOUT\Soap\StructType\SortType $sort1
     * @return \NOUT\Soap\StructType\SpecialParamListType
     */
    public function setSort1(?\NOUT\Soap\StructType\SortType $sort1 = null): self
    {
        $this->Sort1 = $sort1;
        
        return $this;
    }
    /**
     * Get Sort2 value
     * @return \NOUT\Soap\StructType\SortType|null
     */
    public function getSort2(): ?\NOUT\Soap\StructType\SortType
    {
        return $this->Sort2;
    }
    /**
     * Set Sort2 value
     * @param \NOUT\Soap\StructType\SortType $sort2
     * @return \NOUT\Soap\StructType\SpecialParamListType
     */
    public function setSort2(?\NOUT\Soap\StructType\SortType $sort2 = null): self
    {
        $this->Sort2 = $sort2;
        
        return $this;
    }
    /**
     * Get Sort3 value
     * @return \NOUT\Soap\StructType\SortType|null
     */
    public function getSort3(): ?\NOUT\Soap\StructType\SortType
    {
        return $this->Sort3;
    }
    /**
     * Set Sort3 value
     * @param \NOUT\Soap\StructType\SortType $sort3
     * @return \NOUT\Soap\StructType\SpecialParamListType
     */
    public function setSort3(?\NOUT\Soap\StructType\SortType $sort3 = null): self
    {
        $this->Sort3 = $sort3;
        
        return $this;
    }
    /**
     * Get ItemTreeParent value
     * @return string|null
     */
    public function getItemTreeParent(): ?string
    {
        return $this->ItemTreeParent;
    }
    /**
     * Set ItemTreeParent value
     * @param string $itemTreeParent
     * @return \NOUT\Soap\StructType\SpecialParamListType
     */
    public function setItemTreeParent(?string $itemTreeParent = null): self
    {
        // validation for constraint: string
        if (!is_null($itemTreeParent) && !is_string($itemTreeParent)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($itemTreeParent, true), gettype($itemTreeParent)), __LINE__);
        }
        $this->ItemTreeParent = $itemTreeParent;
        
        return $this;
    }
    /**
     * Get OnDemandColumns value
     * @return string|null
     */
    public function getOnDemandColumns(): ?string
    {
        return $this->OnDemandColumns;
    }
    /**
     * Set OnDemandColumns value
     * @param string $onDemandColumns
     * @return \NOUT\Soap\StructType\SpecialParamListType
     */
    public function setOnDemandColumns(?string $onDemandColumns = null): self
    {
        // validation for constraint: string
        if (!is_null($onDemandColumns) && !is_string($onDemandColumns)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($onDemandColumns, true), gettype($onDemandColumns)), __LINE__);
        }
        $this->OnDemandColumns = $onDemandColumns;
        
        return $this;
    }
}
