<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for TransformInto StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class TransformInto extends AbstractStructBase
{
    /**
     * The Table
     * @var string|null
     */
    protected ?string $Table = null;
    /**
     * The TableSrc
     * @var string|null
     */
    protected ?string $TableSrc = null;
    /**
     * The ElemSrc
     * @var string|null
     */
    protected ?string $ElemSrc = null;
    /**
     * The CallingColumn
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string|null
     */
    protected ?string $CallingColumn = null;
    /**
     * The CallingInfo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \NOUT\Soap\StructType\CallingInfoType|null
     */
    protected ?\NOUT\Soap\StructType\CallingInfoType $CallingInfo = null;
    /**
     * Constructor method for TransformInto
     * @uses TransformInto::setTable()
     * @uses TransformInto::setTableSrc()
     * @uses TransformInto::setElemSrc()
     * @uses TransformInto::setCallingColumn()
     * @uses TransformInto::setCallingInfo()
     * @param string $table
     * @param string $tableSrc
     * @param string $elemSrc
     * @param string $callingColumn
     * @param \NOUT\Soap\StructType\CallingInfoType $callingInfo
     */
    public function __construct(?string $table = null, ?string $tableSrc = null, ?string $elemSrc = null, ?string $callingColumn = null, ?\NOUT\Soap\StructType\CallingInfoType $callingInfo = null)
    {
        $this
            ->setTable($table)
            ->setTableSrc($tableSrc)
            ->setElemSrc($elemSrc)
            ->setCallingColumn($callingColumn)
            ->setCallingInfo($callingInfo);
    }
    /**
     * Get Table value
     * @return string|null
     */
    public function getTable(): ?string
    {
        return $this->Table;
    }
    /**
     * Set Table value
     * @param string $table
     * @return \NOUT\Soap\StructType\TransformInto
     */
    public function setTable(?string $table = null): self
    {
        // validation for constraint: string
        if (!is_null($table) && !is_string($table)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($table, true), gettype($table)), __LINE__);
        }
        $this->Table = $table;
        
        return $this;
    }
    /**
     * Get TableSrc value
     * @return string|null
     */
    public function getTableSrc(): ?string
    {
        return $this->TableSrc;
    }
    /**
     * Set TableSrc value
     * @param string $tableSrc
     * @return \NOUT\Soap\StructType\TransformInto
     */
    public function setTableSrc(?string $tableSrc = null): self
    {
        // validation for constraint: string
        if (!is_null($tableSrc) && !is_string($tableSrc)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($tableSrc, true), gettype($tableSrc)), __LINE__);
        }
        $this->TableSrc = $tableSrc;
        
        return $this;
    }
    /**
     * Get ElemSrc value
     * @return string|null
     */
    public function getElemSrc(): ?string
    {
        return $this->ElemSrc;
    }
    /**
     * Set ElemSrc value
     * @param string $elemSrc
     * @return \NOUT\Soap\StructType\TransformInto
     */
    public function setElemSrc(?string $elemSrc = null): self
    {
        // validation for constraint: string
        if (!is_null($elemSrc) && !is_string($elemSrc)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($elemSrc, true), gettype($elemSrc)), __LINE__);
        }
        $this->ElemSrc = $elemSrc;
        
        return $this;
    }
    /**
     * Get CallingColumn value
     * @return string|null
     */
    public function getCallingColumn(): ?string
    {
        return $this->CallingColumn;
    }
    /**
     * Set CallingColumn value
     * @param string $callingColumn
     * @return \NOUT\Soap\StructType\TransformInto
     */
    public function setCallingColumn(?string $callingColumn = null): self
    {
        // validation for constraint: string
        if (!is_null($callingColumn) && !is_string($callingColumn)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($callingColumn, true), gettype($callingColumn)), __LINE__);
        }
        $this->CallingColumn = $callingColumn;
        
        return $this;
    }
    /**
     * Get CallingInfo value
     * @return \NOUT\Soap\StructType\CallingInfoType|null
     */
    public function getCallingInfo(): ?\NOUT\Soap\StructType\CallingInfoType
    {
        return $this->CallingInfo;
    }
    /**
     * Set CallingInfo value
     * @param \NOUT\Soap\StructType\CallingInfoType $callingInfo
     * @return \NOUT\Soap\StructType\TransformInto
     */
    public function setCallingInfo(?\NOUT\Soap\StructType\CallingInfoType $callingInfo = null): self
    {
        $this->CallingInfo = $callingInfo;
        
        return $this;
    }
}
