<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for UpdateMessage StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class UpdateMessage extends AbstractStructBase
{
    /**
     * The IDMessage
     * @var string|null
     */
    protected ?string $IDMessage = null;
    /**
     * The UpdateData
     * @var string|null
     */
    protected ?string $UpdateData = null;
    /**
     * Constructor method for UpdateMessage
     * @uses UpdateMessage::setIDMessage()
     * @uses UpdateMessage::setUpdateData()
     * @param string $iDMessage
     * @param string $updateData
     */
    public function __construct(?string $iDMessage = null, ?string $updateData = null)
    {
        $this
            ->setIDMessage($iDMessage)
            ->setUpdateData($updateData);
    }
    /**
     * Get IDMessage value
     * @return string|null
     */
    public function getIDMessage(): ?string
    {
        return $this->IDMessage;
    }
    /**
     * Set IDMessage value
     * @param string $iDMessage
     * @return \NOUT\Soap\StructType\UpdateMessage
     */
    public function setIDMessage(?string $iDMessage = null): self
    {
        // validation for constraint: string
        if (!is_null($iDMessage) && !is_string($iDMessage)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($iDMessage, true), gettype($iDMessage)), __LINE__);
        }
        $this->IDMessage = $iDMessage;
        
        return $this;
    }
    /**
     * Get UpdateData value
     * @return string|null
     */
    public function getUpdateData(): ?string
    {
        return $this->UpdateData;
    }
    /**
     * Set UpdateData value
     * @param string $updateData
     * @return \NOUT\Soap\StructType\UpdateMessage
     */
    public function setUpdateData(?string $updateData = null): self
    {
        // validation for constraint: string
        if (!is_null($updateData) && !is_string($updateData)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($updateData, true), gettype($updateData)), __LINE__);
        }
        $this->UpdateData = $updateData;
        
        return $this;
    }
}
