<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for UsernameTokenType StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class UsernameTokenType extends AbstractStructBase
{
    /**
     * The Username
     * @var string|null
     */
    protected ?string $Username = null;
    /**
     * The Password
     * @var string|null
     */
    protected ?string $Password = null;
    /**
     * The Nonce
     * @var string|null
     */
    protected ?string $Nonce = null;
    /**
     * The Created
     * @var string|null
     */
    protected ?string $Created = null;
    /**
     * The Encryption
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \NOUT\Soap\StructType\EncryptionType|null
     */
    protected ?\NOUT\Soap\StructType\EncryptionType $Encryption = null;
    /**
     * Constructor method for UsernameTokenType
     * @uses UsernameTokenType::setUsername()
     * @uses UsernameTokenType::setPassword()
     * @uses UsernameTokenType::setNonce()
     * @uses UsernameTokenType::setCreated()
     * @uses UsernameTokenType::setEncryption()
     * @param string $username
     * @param string $password
     * @param string $nonce
     * @param string $created
     * @param \NOUT\Soap\StructType\EncryptionType $encryption
     */
    public function __construct(?string $username = null, ?string $password = null, ?string $nonce = null, ?string $created = null, ?\NOUT\Soap\StructType\EncryptionType $encryption = null)
    {
        $this
            ->setUsername($username)
            ->setPassword($password)
            ->setNonce($nonce)
            ->setCreated($created)
            ->setEncryption($encryption);
    }
    /**
     * Get Username value
     * @return string|null
     */
    public function getUsername(): ?string
    {
        return $this->Username;
    }
    /**
     * Set Username value
     * @param string $username
     * @return \NOUT\Soap\StructType\UsernameTokenType
     */
    public function setUsername(?string $username = null): self
    {
        // validation for constraint: string
        if (!is_null($username) && !is_string($username)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($username, true), gettype($username)), __LINE__);
        }
        $this->Username = $username;
        
        return $this;
    }
    /**
     * Get Password value
     * @return string|null
     */
    public function getPassword(): ?string
    {
        return $this->Password;
    }
    /**
     * Set Password value
     * @param string $password
     * @return \NOUT\Soap\StructType\UsernameTokenType
     */
    public function setPassword(?string $password = null): self
    {
        // validation for constraint: string
        if (!is_null($password) && !is_string($password)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($password, true), gettype($password)), __LINE__);
        }
        $this->Password = $password;
        
        return $this;
    }
    /**
     * Get Nonce value
     * @return string|null
     */
    public function getNonce(): ?string
    {
        return $this->Nonce;
    }
    /**
     * Set Nonce value
     * @param string $nonce
     * @return \NOUT\Soap\StructType\UsernameTokenType
     */
    public function setNonce(?string $nonce = null): self
    {
        // validation for constraint: string
        if (!is_null($nonce) && !is_string($nonce)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($nonce, true), gettype($nonce)), __LINE__);
        }
        $this->Nonce = $nonce;
        
        return $this;
    }
    /**
     * Get Created value
     * @return string|null
     */
    public function getCreated(): ?string
    {
        return $this->Created;
    }
    /**
     * Set Created value
     * @param string $created
     * @return \NOUT\Soap\StructType\UsernameTokenType
     */
    public function setCreated(?string $created = null): self
    {
        // validation for constraint: string
        if (!is_null($created) && !is_string($created)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($created, true), gettype($created)), __LINE__);
        }
        $this->Created = $created;
        
        return $this;
    }
    /**
     * Get Encryption value
     * @return \NOUT\Soap\StructType\EncryptionType|null
     */
    public function getEncryption(): ?\NOUT\Soap\StructType\EncryptionType
    {
        return $this->Encryption;
    }
    /**
     * Set Encryption value
     * @param \NOUT\Soap\StructType\EncryptionType $encryption
     * @return \NOUT\Soap\StructType\UsernameTokenType
     */
    public function setEncryption(?\NOUT\Soap\StructType\EncryptionType $encryption = null): self
    {
        $this->Encryption = $encryption;
        
        return $this;
    }
}
