<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for ValidateError StructType
 * Meta information extracted from the WSDL
 * - type: tns:ValidateError
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class ValidateError extends AbstractStructBase
{
    /**
     * The Message
     * @var string|null
     */
    protected ?string $Message = null;
    /**
     * The ListCol
     * @var \NOUT\Soap\StructType\ColumnListType|null
     */
    protected ?\NOUT\Soap\StructType\ColumnListType $ListCol = null;
    /**
     * Constructor method for ValidateError
     * @uses ValidateError::setMessage()
     * @uses ValidateError::setListCol()
     * @param string $message
     * @param \NOUT\Soap\StructType\ColumnListType $listCol
     */
    public function __construct(?string $message = null, ?\NOUT\Soap\StructType\ColumnListType $listCol = null)
    {
        $this
            ->setMessage($message)
            ->setListCol($listCol);
    }
    /**
     * Get Message value
     * @return string|null
     */
    public function getMessage(): ?string
    {
        return $this->Message;
    }
    /**
     * Set Message value
     * @param string $message
     * @return \NOUT\Soap\StructType\ValidateError
     */
    public function setMessage(?string $message = null): self
    {
        // validation for constraint: string
        if (!is_null($message) && !is_string($message)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($message, true), gettype($message)), __LINE__);
        }
        $this->Message = $message;
        
        return $this;
    }
    /**
     * Get ListCol value
     * @return \NOUT\Soap\StructType\ColumnListType|null
     */
    public function getListCol(): ?\NOUT\Soap\StructType\ColumnListType
    {
        return $this->ListCol;
    }
    /**
     * Set ListCol value
     * @param \NOUT\Soap\StructType\ColumnListType $listCol
     * @return \NOUT\Soap\StructType\ValidateError
     */
    public function setListCol(?\NOUT\Soap\StructType\ColumnListType $listCol = null): self
    {
        $this->ListCol = $listCol;
        
        return $this;
    }
}
