<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for ValidateFolder StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class ValidateFolder extends AbstractStructBase
{
    /**
     * The IDFolder
     * @var string|null
     */
    protected ?string $IDFolder = null;
    /**
     * Constructor method for ValidateFolder
     * @uses ValidateFolder::setIDFolder()
     * @param string $iDFolder
     */
    public function __construct(?string $iDFolder = null)
    {
        $this
            ->setIDFolder($iDFolder);
    }
    /**
     * Get IDFolder value
     * @return string|null
     */
    public function getIDFolder(): ?string
    {
        return $this->IDFolder;
    }
    /**
     * Set IDFolder value
     * @param string $iDFolder
     * @return \NOUT\Soap\StructType\ValidateFolder
     */
    public function setIDFolder(?string $iDFolder = null): self
    {
        // validation for constraint: string
        if (!is_null($iDFolder) && !is_string($iDFolder)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($iDFolder, true), gettype($iDFolder)), __LINE__);
        }
        $this->IDFolder = $iDFolder;
        
        return $this;
    }
}
