<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for VirtualParamType StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class VirtualParamType extends AbstractStructBase
{
    /**
     * The _
     * @var string|null
     */
    protected ?string $_ = null;
    /**
     * The modelId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string|null
     */
    protected ?string $modelId = null;
    /**
     * The columnId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string|null
     */
    protected ?string $columnId = null;
    /**
     * The required
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int|null
     */
    protected ?int $required = null;
    /**
     * The hidden
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int|null
     */
    protected ?int $hidden = null;
    /**
     * Constructor method for VirtualParamType
     * @uses VirtualParamType::set_()
     * @uses VirtualParamType::setModelId()
     * @uses VirtualParamType::setColumnId()
     * @uses VirtualParamType::setRequired()
     * @uses VirtualParamType::setHidden()
     * @param string $_
     * @param string $modelId
     * @param string $columnId
     * @param int $required
     * @param int $hidden
     */
    public function __construct(?string $_ = null, ?string $modelId = null, ?string $columnId = null, ?int $required = null, ?int $hidden = null)
    {
        $this
            ->set_($_)
            ->setModelId($modelId)
            ->setColumnId($columnId)
            ->setRequired($required)
            ->setHidden($hidden);
    }
    /**
     * Get _ value
     * @return string|null
     */
    public function get_(): ?string
    {
        return $this->_;
    }
    /**
     * Set _ value
     * @param string $_
     * @return \NOUT\Soap\StructType\VirtualParamType
     */
    public function set_(?string $_ = null): self
    {
        // validation for constraint: string
        if (!is_null($_) && !is_string($_)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($_, true), gettype($_)), __LINE__);
        }
        $this->_ = $_;
        
        return $this;
    }
    /**
     * Get modelId value
     * @return string|null
     */
    public function getModelId(): ?string
    {
        return $this->modelId;
    }
    /**
     * Set modelId value
     * @param string $modelId
     * @return \NOUT\Soap\StructType\VirtualParamType
     */
    public function setModelId(?string $modelId = null): self
    {
        // validation for constraint: string
        if (!is_null($modelId) && !is_string($modelId)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($modelId, true), gettype($modelId)), __LINE__);
        }
        $this->modelId = $modelId;
        
        return $this;
    }
    /**
     * Get columnId value
     * @return string|null
     */
    public function getColumnId(): ?string
    {
        return $this->columnId;
    }
    /**
     * Set columnId value
     * @param string $columnId
     * @return \NOUT\Soap\StructType\VirtualParamType
     */
    public function setColumnId(?string $columnId = null): self
    {
        // validation for constraint: string
        if (!is_null($columnId) && !is_string($columnId)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($columnId, true), gettype($columnId)), __LINE__);
        }
        $this->columnId = $columnId;
        
        return $this;
    }
    /**
     * Get required value
     * @return int|null
     */
    public function getRequired(): ?int
    {
        return $this->required;
    }
    /**
     * Set required value
     * @param int $required
     * @return \NOUT\Soap\StructType\VirtualParamType
     */
    public function setRequired(?int $required = null): self
    {
        // validation for constraint: int
        if (!is_null($required) && !(is_int($required) || ctype_digit($required))) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($required, true), gettype($required)), __LINE__);
        }
        $this->required = $required;
        
        return $this;
    }
    /**
     * Get hidden value
     * @return int|null
     */
    public function getHidden(): ?int
    {
        return $this->hidden;
    }
    /**
     * Set hidden value
     * @param int $hidden
     * @return \NOUT\Soap\StructType\VirtualParamType
     */
    public function setHidden(?int $hidden = null): self
    {
        // validation for constraint: int
        if (!is_null($hidden) && !(is_int($hidden) || ctype_digit($hidden))) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($hidden, true), gettype($hidden)), __LINE__);
        }
        $this->hidden = $hidden;
        
        return $this;
    }
}
