<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for WithAutomaticResponse StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class WithAutomaticResponse extends AbstractStructBase
{
    /**
     * The IDMessage
     * @var string|null
     */
    protected ?string $IDMessage = null;
    /**
     * The ResponseType
     * @var int|null
     */
    protected ?int $ResponseType = null;
    /**
     * The SendAutomaticMessage
     * @var int|null
     */
    protected ?int $SendAutomaticMessage = null;
    /**
     * Constructor method for WithAutomaticResponse
     * @uses WithAutomaticResponse::setIDMessage()
     * @uses WithAutomaticResponse::setResponseType()
     * @uses WithAutomaticResponse::setSendAutomaticMessage()
     * @param string $iDMessage
     * @param int $responseType
     * @param int $sendAutomaticMessage
     */
    public function __construct(?string $iDMessage = null, ?int $responseType = null, ?int $sendAutomaticMessage = null)
    {
        $this
            ->setIDMessage($iDMessage)
            ->setResponseType($responseType)
            ->setSendAutomaticMessage($sendAutomaticMessage);
    }
    /**
     * Get IDMessage value
     * @return string|null
     */
    public function getIDMessage(): ?string
    {
        return $this->IDMessage;
    }
    /**
     * Set IDMessage value
     * @param string $iDMessage
     * @return \NOUT\Soap\StructType\WithAutomaticResponse
     */
    public function setIDMessage(?string $iDMessage = null): self
    {
        // validation for constraint: string
        if (!is_null($iDMessage) && !is_string($iDMessage)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($iDMessage, true), gettype($iDMessage)), __LINE__);
        }
        $this->IDMessage = $iDMessage;
        
        return $this;
    }
    /**
     * Get ResponseType value
     * @return int|null
     */
    public function getResponseType(): ?int
    {
        return $this->ResponseType;
    }
    /**
     * Set ResponseType value
     * @param int $responseType
     * @return \NOUT\Soap\StructType\WithAutomaticResponse
     */
    public function setResponseType(?int $responseType = null): self
    {
        // validation for constraint: int
        if (!is_null($responseType) && !(is_int($responseType) || ctype_digit($responseType))) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($responseType, true), gettype($responseType)), __LINE__);
        }
        $this->ResponseType = $responseType;
        
        return $this;
    }
    /**
     * Get SendAutomaticMessage value
     * @return int|null
     */
    public function getSendAutomaticMessage(): ?int
    {
        return $this->SendAutomaticMessage;
    }
    /**
     * Set SendAutomaticMessage value
     * @param int $sendAutomaticMessage
     * @return \NOUT\Soap\StructType\WithAutomaticResponse
     */
    public function setSendAutomaticMessage(?int $sendAutomaticMessage = null): self
    {
        // validation for constraint: int
        if (!is_null($sendAutomaticMessage) && !(is_int($sendAutomaticMessage) || ctype_digit($sendAutomaticMessage))) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($sendAutomaticMessage, true), gettype($sendAutomaticMessage)), __LINE__);
        }
        $this->SendAutomaticMessage = $sendAutomaticMessage;
        
        return $this;
    }
}
