<?php

declare(strict_types=1);

namespace NOUT\Soap\StructType;

use InvalidArgumentException;
use NOUT\Soap\PackageBase\AbstractStructBase;

/**
 * This class stands for XmlType StructType
 * @subpackage Structs
 */
#[\AllowDynamicProperties]
class XmlType extends AbstractStructBase
{
    /**
     * The xml
     * @var string|null
     */
    protected ?string $xml = null;
    /**
     * Constructor method for XmlType
     * @uses XmlType::setXml()
     * @param string $xml
     */
    public function __construct(?string $xml = null)
    {
        $this
            ->setXml($xml);
    }
    /**
     * Get xml value
     * @return string|null
     */
    public function getXml(): ?string
    {
        return $this->xml;
    }
    /**
     * Set xml value
     * @param string $xml
     * @return \NOUT\Soap\StructType\XmlType
     */
    public function setXml(?string $xml = null): self
    {
        // validation for constraint: string
        if (!is_null($xml) && !is_string($xml)) {
            throw new InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($xml, true), gettype($xml)), __LINE__);
        }
        $this->xml = $xml;
        
        return $this;
    }
}
