<?php
/**
 * script pour la modification des enregistrement (formulaire) du plugin (simaxFormSubmiter)
 */	
 
define('sfs_sumitFormEdit_SubmitButton', 'sfs_submitEditForm');
define('SFS_EDITFORM_TITLE','sfs_editForm_formTitle');
define('SFS_EDITFORM_SIMAXFORM','sfs_editForm_simaxForm');
define('SFS_EDITFORM_FORMDESC','sfs_editForm_FormDesc');
define('SFS_EDITFORM_NOKMESS','sfs_editForm_NOKMess');
define('SFS_EDITFORM_OKMESS','sfs_editForm_OkMess');
define('SFS_EDITFORM_RECUPMAIL','sfs_editForm_recupMail');
 
//on recupere les eventuel info de la requete de page :
$aQueryVars;
parse_str($_SERVER['QUERY_STRING'], $aQueryVars);

$sMessage = '';
$bDisplayForm = true;

//On n'a pas d'enregistrement demander
if(!isset($aQueryVars['form-id']) && $aQueryVars['form-id'] == '')
{
	$sMessage = 'Aucuns enregistrement n\'est fournis.';
	$bDisplayForm = false;
}
//si on a soumission du formulaire, on update l'enregistrement
elseif(isset($_POST[sfs_sumitFormEdit_SubmitButton]) && $_POST['form-id'])
{
	global $o_sfs_dbGest;
	
	//on prepare les données a mettre a jour (en fonction de celle fourni):
	$aToUpdate = array();
	if(isset($_POST[ SFS_EDITFORM_TITLE ]) && $_POST[ SFS_EDITFORM_TITLE ] != '')
	{
		$aToUpdate[ sfs_clEnumDbCols::sTitle ] = $_POST[ SFS_EDITFORM_TITLE ];
	}
	if(isset($_POST[ SFS_EDITFORM_SIMAXFORM ]) && $_POST[ SFS_EDITFORM_SIMAXFORM ] != '')
	{
		$aToUpdate[ sfs_clEnumDbCols::sIdSimaxForm ] = $_POST[ SFS_EDITFORM_SIMAXFORM ];
	}
	if(isset($_POST[ SFS_EDITFORM_FORMDESC ]) && $_POST[ SFS_EDITFORM_FORMDESC ] != '')
	{
		$aToUpdate[ sfs_clEnumDbCols::sFormDesc ] = $_POST[ SFS_EDITFORM_FORMDESC ];
	}
	if(isset($_POST[ SFS_EDITFORM_NOKMESS ]) && $_POST[ SFS_EDITFORM_NOKMESS ] != '')
	{
		$aToUpdate[ sfs_clEnumDbCols::sError ] = $_POST[ SFS_EDITFORM_NOKMESS ];
	}
	if(isset($_POST[ SFS_EDITFORM_OKMESS ]) && $_POST[ SFS_EDITFORM_OKMESS ] != '')
	{
		$aToUpdate[ sfs_clEnumDbCols::sSuccess ] = $_POST[ SFS_EDITFORM_OKMESS ];
	}
	if(isset($_POST[ SFS_EDITFORM_RECUPMAIL ]) && $_POST[ SFS_EDITFORM_RECUPMAIL ] != '')
	{
		$aToUpdate[ sfs_clEnumDbCols::sRecupMail ] = $_POST[ SFS_EDITFORM_RECUPMAIL ];
	}
	
	$mResp = $o_sfs_dbGest->update_enreg($_POST['form-id'],$aToUpdate);
	
	if($mResp)
	{
		$sMessage = 'Le formulaire &agrave; bien &eacute;t&eacute; mis &agrave; jour.';
	}
	else
	{
		$sMessage = 'Echec lors de la mise &agrave; jour du formulaire.';
	}
}

//si il le faut, on charge l'enregistrement.
if($bDisplayForm)
{
	global $o_sfs_dbGest;
	//on recupere l'enregistrement 
	$aEnregDesc = $o_sfs_dbGest->get_enreg_desc($aQueryVars['form-id']);
	
	//l'enregistrement n'existe pas
	if(!isset($aEnregDesc) || !is_array($aEnregDesc) || empty($aEnregDesc))
	{
		$sMessage = 'l\'enregistrement demand&eacute; n\'existe pas.';
		$bDisplayForm = false;
	}
}

?>

<div class="wrap">
	<div id="icon-edit-pages" class="icon32" style="background-position:-190px -5px"></div>
	<h2 style="color margin-bottom:20px">Editer le formulaire : </h2>
	<?php if($sMessage != '') : ?>	
		<div class="updated settings-error below-h2" id="setting-error-settings_updated">
			<p>
				<strong><?php echo $sMessage; ?></strong>
			</p>
		</div>
	<?php endif; 
	if($bDisplayForm) : ?>
		<form action='' method='post'>
			<input type="hidden" name= "form-id" value="<?php echo $aQueryVars['form-id'];?>" />
			<input type="submit" class="button-secondary" name="<?php echo sfs_sumitFormEdit_SubmitButton; ?>" value="Valider" />
			<table class="form-table">
				<tbody>
					<tr vertical-align="top">
						<th scope="row">
							<label for="">ShortCode</label>
						</th>
						<td>
							<input id="" class="regular-text" type="text" readonly="readonly" value='[sfs-form-identification id="<?php echo $aEnregDesc[ sfs_clEnumDbCols::sIdRow ];?>" titre="<?php echo $aEnregDesc[ sfs_clEnumDbCols::sTitle ];?>" /]' name="">
						</td>
					</tr>
					
					<tr vertical-align="top">
						<th scope="row">
							<label for="idTitle">Titre</label>
						</th>
						<td>
							<input id="idTitle" class="regular-text" type="text" value='<?php echo $aEnregDesc[sfs_clEnumDbCols::sTitle]; ?>' name="<?php echo SFS_EDITFORM_TITLE; ?>" />
						</td>
					</tr>
					
					<tr vertical-align="top">
						<th scope="row">
							<label for="idSimaxForm">Identifiant du formulaire Simax</label>
						</th>
						<td>
							<input id="idSimaxForm" class="regular-text" type="text" value='<?php echo $aEnregDesc[sfs_clEnumDbCols::sIdSimaxForm]; ?>' name="<?php echo SFS_EDITFORM_SIMAXFORM;?>" />
						</td>
					</tr>
					
					
					<tr vertical-align="top">
						<th scope="row">
							<label for="idFormDesc">Description formulaire (HTML)</label>
						</th>
						<td>
							<textarea id="idFormDesc" class="large-text code" cols="50" rows="10" name="<?php echo SFS_EDITFORM_FORMDESC; ?>"><?php echo htmlspecialchars( $aEnregDesc[sfs_clEnumDbCols::sFormDesc] ); ?></textarea>
						</td>
					</tr>
					
					<tr vertical-align="top">
						<th scope="row">
							<label for="idNokMess">Message d'erreur</label>
						</th>
						<td>
							<textarea id="idNokMess" class="large-text code" cols="50" rows="10" name="<?php echo SFS_EDITFORM_NOKMESS;?>"><?php echo htmlspecialchars( $aEnregDesc[sfs_clEnumDbCols::sError] ); ?></textarea>
						</td>
					</tr>
					
					<tr vertical-align="top">
						<th scope="row">
							<label for="idOkMess">Message de r&eacute;ussite</label>
						</th>
						<td>
							<textarea id="idOkMess" class="large-text code" cols="50" rows="10" name="<?php echo SFS_EDITFORM_OKMESS;?>"><?php echo htmlspecialchars( $aEnregDesc[sfs_clEnumDbCols::sSuccess] ); ?></textarea>
						</td>
					</tr>				
					
				
					<tr vertical-align="top">
						<th scope="row">
							<label for="idMail">Email de r&eacute;cup&eacute;ration</label>
						</th>
						<td>
							<input id="idMail" class="regular-text" type="text" value='<?php echo $aEnregDesc[sfs_clEnumDbCols::sRecupMail]; ?>' name="<?php echo SFS_EDITFORM_RECUPMAIL;?>" />
						</td>
					</tr>

				</tbody>
			</table>
			<input type="submit" class="button-secondary" name="<?php echo sfs_sumitFormEdit_SubmitButton; ?>" value="Valider" />
		</form>		
	<?php endif; ?>
</div>
