<?php

/**
 * Page permettant l'edition des options du pluggins simaxFormSubmitter
 */

//gestion des affichage d'erreur ou de réussite :
$sfs_editOptionError   = '';
$sfs_editOptionSuccess = '';

//On recupere les option
//instanciation classe gestion des options.
$oSettingsGest = new sfs_clSettingsGest();

//-----
//si on a soumission d'un formulaire on fait les action approprié
if ($_SERVER['REQUEST_METHOD'] == 'POST') {
    if ($oSettingsGest->update_multiple_option($_POST)) {
        $sfs_editOptionSuccess = 'La modification des options &agrave; bien &eacute;t&eacute; effectu&eacute;.';
    }
    else {
        $sfs_editOptionError = 'Erreur lors de la modification des options.';
    }
}

//----
//On recupere les option
$aOptList = $oSettingsGest->list_options_value([
                                                   sfs_clEnumOption::sTypeAdresse     => '',
                                                   sfs_clEnumOption::sUrl             => '',
                                                   sfs_clEnumOption::sHost            => '',
                                                   sfs_clEnumOption::sPort            => '',
                                                   sfs_clEnumOption::sUserApiuuId     => '',
                                                   sfs_clEnumOption::bTraces          => '0',
                                                   sfs_clEnumOption::sToken           => '',
                                                   sfs_clEnumOption::sTokenTime       => '',
                                                   sfs_clEnumOption::sSecretPhrase    => '',
                                                   sfs_clEnumOption::sEmailRecupError => '',
                                                   sfs_clEnumOption::sErrorMessage    => '',
                                                   sfs_clEnumOption::sSuccessMessage  => '',
                                               ]);
?>

<div class="wrap">

    <div id="icon-edit-pages" class="icon32" style="background-position:-190px -5px"></div>
    <h2>Options du plugin simaxFormSubmiter </h2>

    <?php
    if ($sfs_editOptionError != '' || $sfs_editOptionSuccess != '') {
        ?>
        <div id="setting-error-settings_updated" class="updated settings-error">
            <p>
                <strong><?php
                    echo $sfs_editOptionError . $sfs_editOptionSuccess; ?></strong>
            </p>
        </div>
        <?php
    }
    ?>

    <?php
    if ( !extension_loaded("soap")) {
        ?>
        <div class="notice notice-error gutena-forms-admin-notice" style="display:flex;align-items:center; gap:6px;">
            <p><strong>! Extension Manquante</strong> L'extension <strong>SOAP</strong> est manquante, activez
                l'extension SOAP dans le fichier php.ini</p>
        </div>
        <?php
    }
    ?>

    <?php
    if ( !extension_loaded("curl")) {
        ?>
        <div class="notice notice-error gutena-forms-admin-notice" style="display:flex;align-items:center; gap:6px;">
            <p><strong>! Extension Manquante</strong> L'extension <strong>CURL</strong> est manquante, activez
                l'extension CURL dans le fichier php.ini</p>
        </div>
        <?php
    }
    ?>

    <?php
    if (empty($aOptList[sfs_clEnumOption::sToken])) {
        ?>
        <div class="notice notice-error gutena-forms-admin-notice" style="display:flex;align-items:center; gap:6px;">
            <p><strong>! Token Manquant</strong> L'utilisation d'un token est <strong>obligatoire</strong> pour faire
                fonctionner votre module</p>
        </div>
        <?php
    }
    ?>
    <!-- Formulaire pour modification des options generales -->
    <form action="" method="post">
        <h3>Connexion SIMAXOnline : </h3>
        <?php
            $typecnx = $aOptList[sfs_clEnumOption::sTypeAdresse];
            $url = $aOptList[sfs_clEnumOption::sUrl];
            $host = $aOptList[sfs_clEnumOption::sHost] ?? '';
            $port = $aOptList[sfs_clEnumOption::sPort] ?? '';

            if (empty($typecnx) && !empty($url)){
                if(preg_match_all('/^http:\/\/(?<host>[^:]+):(?<port>\d+)\/?/mi', $url, $matches)){
                    $url = '';
                    $typecnx = 'direct';
                    $host = $matches['host'][0];
                    $port = $matches['port'][0];

                    update_option(sfs_clEnumOption::sTypeAdresse, $typecnx);
                    update_option(sfs_clEnumOption::sUrl, $url);
                    update_option(sfs_clEnumOption::sHost, $host);
                    update_option(sfs_clEnumOption::sPort, $port);
                }
                elseif (str_starts_with($url, 'https://')) {
                    $typecnx = 'proxy';
                    update_option(sfs_clEnumOption::sTypeAdresse, $typecnx);
                }
            }

        ?>
        <table class="form-table">
            <tbody>
                <tr style="vertical-align: top;">
                    <th scope="row">
                        <label for="serviceadr">direct / proxy</label>
                    </th>
                    <td>
                        <label for="direct">direct</label>
                        <input id="direct" class="regular-text" type="radio"
                               value="direct"
                               name="<?php echo sfs_clEnumOption::sTypeAdresse; ?>" onchange="toggleServiceType()"
                               <?php echo $typecnx == 'direct' ? 'checked' : '' ;?>
                        >

                        <label for="proxy">proxy</label>
                        <input id="proxy" class="regular-text" type="radio" value="proxy"
                                <?php echo $typecnx == 'proxy' ? 'checked' : '' ;?>
                               name="<?php echo sfs_clEnumOption::sTypeAdresse; ?>" onchange="toggleServiceType()"
                        >
                    </td>
                </tr>

                <!-- Champ pour "Adresse du service" -->
                <tr id="service-address-row" style="vertical-align: top; display: none;">
                    <th scope="row">
                        <label for="serviceadr">Adresse du service (adresse service)</label>
                    </th>
                    <td>
                        <input id="serviceadr" class="regular-text" type="text" value="<?php
                        echo $host; ?>" name="<?php
                        echo sfs_clEnumOption::sHost; ?>">
                        :
                        <input id="serviceprt" class="regular-text" type="text" value="<?php
                        echo $port; ?>" name="<?php
                        echo sfs_clEnumOption::sPort; ?>">
                    </td>
                </tr>

                <!-- Champ pour "Url" -->
                <tr id="service-url-row" style="vertical-align: top; display: none;">
                    <th scope="row">
                        <label for="serviceprt">Url</label>
                    </th>
                    <td>
                        <input id="serviceprt" class="regular-text" type="text" value="<?php
                        echo $url; ?>" name="<?php
                        echo sfs_clEnumOption::sUrl; ?>">
                    </td>
                </tr>


                <tr style="vertical-align: top;">
                    <th scope="row">
                        <label for="serviceapiuuid">Identifiant de l'application</label>
                    </th>
                    <td>
                        <input id="serviceapiuuid" class="regular-text" type="text" value="<?php
                        if (empty($aOptList[sfs_clEnumOption::sUserApiuuId])) {
                            echo sfs_clFormSubmiter::APIUUID;
                        }
                        else {
                            echo $aOptList[sfs_clEnumOption::sUserApiuuId];
                        } ?>" name="<?php echo sfs_clEnumOption::sUserApiuuId; ?>">
                    </td>
                </tr>
            </tbody>
        </table>

        <h3>Authentification : </h3>
        <table class="form-table">
            <tbody>
                <tr style="vertical-align: top;">
                    <th scope="row">
                        <label for="token">Token</label>
                    </th>
                    <td>
                        <textarea id="token" class="large-text" name="<?php
                        echo sfs_clEnumOption::sToken; ?>"><?php
                            echo $aOptList[sfs_clEnumOption::sToken]; ?></textarea>
                    </td>
                </tr>
                <tr style="vertical-align: top;">
                    <th scope="row">
                        <label for="tokentime">Date d'expiration du token</label>
                    </th>
                    <td>
                        <input id="tokentime" class="regular-text" type="date" value="<?php
                        echo $aOptList[sfs_clEnumOption::sTokenTime]; ?>" name="<?php
                        echo sfs_clEnumOption::sTokenTime; ?>">
                    </td>
                </tr>
                <tr style="vertical-align: top;">
                    <th scope="row">
                        <label for="secretphrase">Phrase secrete <br> <small>(si vide, phrase par défaut)</small></label>
                    </th>
                    <td>
                        <textarea id="secretphrase" class="large-text code" cols="50" rows="10" name="<?php echo sfs_clEnumOption::sSecretPhrase; ?>">
                            <?php echo htmlspecialchars(stripslashes($aOptList[sfs_clEnumOption::sSecretPhrase])); ?>
                        </textarea>
                    </td>
                </tr>

            </tbody>
        </table>

        <h3>Gestion du retour : </h3>
        <table class="form-table">
            <tbody>
                <tr style="vertical-align: top;">
                    <th scope="row">
                        <label for="serviceerror">Message d'erreur</label>
                    </th>
                    <td>
                        <textarea id="serviceerror" class="large-text code" cols="50" rows="10" name="<?php
                        echo sfs_clEnumOption::sErrorMessage; ?>"><?php
                            echo htmlspecialchars(stripslashes($aOptList[sfs_clEnumOption::sErrorMessage])); ?></textarea>
                    </td>
                </tr>

                <tr style="vertical-align: top;">
                    <th scope="row">
                        <label for="servicecommunicationok">Message de r&eacute;ussite</label>
                    </th>
                    <td>
                        <textarea id="servicecommunicationok" class="large-text code" cols="50" rows="10" name="<?php
                        echo sfs_clEnumOption::sSuccessMessage; ?>"><?php
                            echo htmlspecialchars(stripslashes($aOptList[sfs_clEnumOption::sSuccessMessage])); ?></textarea>
                    </td>
                </tr>

                <tr style="vertical-align: top;">
                    <th scope="row">
                        <label for="recupmail">E-mail de recuperation</label>
                    </th>
                    <td>
                        <input id="recupmail" class="regular-text" type="text" value="<?php
                        echo $aOptList[sfs_clEnumOption::sEmailRecupError]; ?>" name="<?php
                        echo sfs_clEnumOption::sEmailRecupError; ?>">
                    </td>
                </tr>

            </tbody>
        </table>

        <h3>Debuggage : </h3>
        <table class="form-table">
            <tbody>
                <tr style="vertical-align: top;">
                    <th scope="row">
                        <label for="traces">activer les traces</label> <br>
                        <small>(Fichiers de débug)</small>
                    </th>
                    <td>
                        <?php
                        $value   = intval($aOptList[sfs_clEnumOption::bTraces]);
                        $checked = intval($aOptList[sfs_clEnumOption::bTraces]) ? 'checked' : '';
                        ?>
                        <input id="traces" class="regular-text" type="checkbox"
                               name="<?php echo sfs_clEnumOption::bTraces; ?>"
                               value="<?php echo $value; ?>"
                               onchange="toggleTraces()"
                            <?php
                            echo $checked; ?>
                        >
                    </td>
                </tr>
            </tbody>
        </table>
        <p class="submit">
            <input id="submit" class="button-primary" type="submit" value="Enregistrer les modifications" name="submit">
        </p>
    </form>
</div>

<script>
    function toggleServiceType() {
        // Obtenir les éléments des boutons radio
        const direct = document.getElementById('direct');
        const proxy = document.getElementById('proxy');

        // Obtenir les éléments des lignes d'input
        const serviceAddressRow = document.getElementById('service-address-row');
        const serviceUrlRow = document.getElementById('service-url-row');

        // Si "direct" est coché, afficher l'input pour l'adresse du service
        if (direct.checked) {
            serviceAddressRow.style.display = 'table-row';
            serviceUrlRow.style.display = 'none';
        }
        // Si "proxy" est coché, afficher l'input pour l'URL
        else if (proxy.checked) {
            serviceAddressRow.style.display = 'none';
            serviceUrlRow.style.display = 'table-row';
        }
    }

    function toggleTraces()
    {
        const traces = document.getElementById('traces');
        if (traces.checked){
            traces.value = "1";
        }
        else {
            traces.value = "0";
        }

    }

    // Appeler la fonction une fois pour le chargement initial, au cas où un bouton serait déjà coché
    window.onload = function () {
        toggleServiceType();
    };
</script>
